// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.CORBA;

//
// ObjectImpl is the base class for proprietary stubs with full
// interceptor support
//
abstract public class ObjectImpl extends org.omg.CORBA_2_4.portable.ObjectImpl
{
    public com.ooc.OB.DowncallStub
    _OB_getDowncallStub()
        throws com.ooc.OB.LocationForward,
               com.ooc.OB.FailureException
    {
        Delegate delegate = (Delegate)_get_delegate();
        return delegate._OB_getDowncallStub(this);
    }

    public void
    _OB_handleException(Exception ex, RetryInfo info)
    {
        Delegate delegate = (Delegate)_get_delegate();
        delegate._OB_handleException(this, ex, info, false);
    }

    public com.ooc.OB.GIOPOutgoingMessage
    _OB_ami_router_preMarshal(String operation, boolean responseExpected,
	                      OutputStreamHolder out,
		              com.ooc.OCI.ProfileInfoHolder info)
    {
	Delegate delegate = (Delegate)_get_delegate();
	
        try
        {
            com.ooc.OB.DowncallStub downStub =
                delegate._OB_getDowncallStub(this);
	    com.ooc.OB.GIOPOutgoingMessage message = 
	        downStub.AMIRouterPreMarshal(operation, responseExpected,
			                     out, info);

	    return message;
        }
        catch(com.ooc.OB.LocationForward ex)
        {
        }
        catch(com.ooc.OB.FailureException ex)
        {
        }

	return null;
    }

    public void
    _OB_ami_router_postMarshal(com.ooc.OB.GIOPOutgoingMessage message,
	                       OutputStreamHolder out)
    {
	Delegate delegate = (Delegate)_get_delegate();
        
	try
        {
            com.ooc.OB.DowncallStub downStub =
                delegate._OB_getDowncallStub(this);
	    downStub.AMIRouterPostMarshal(message, out);
        }
        catch(com.ooc.OB.LocationForward ex)
        {
        }
        catch(com.ooc.OB.FailureException ex)
        {
        }
    }

    //public com.ooc.CORBA.OutputStream
    public com.ooc.OB.CodeConverters
    _OB_setup_ami_poll_request(org.omg.IOP.ServiceContextListHolder sclHolder,
	                       com.ooc.CORBA.OutputStreamHolder out)
    {
        Delegate delegate = (Delegate)_get_delegate();

        try
        {
            com.ooc.OB.DowncallStub downStub =
                delegate._OB_getDowncallStub(this);
	    com.ooc.OB.CodeConverters cc = 
		downStub.setupPollingRequest(sclHolder, out);

	    return cc;
        }
        catch(com.ooc.OB.LocationForward ex)
        {
        }
        catch(com.ooc.OB.FailureException ex)
        {
        }

	return null;
    }
	
   
    public org.omg.CORBA.Object
    _OB_get_ami_poll_target()
    {
        //
	// This is needed since we don't have access to the IOR information
	// from the DowncallStub like we do in C++ (MarshalStub)
	//
	Delegate delegate = (Delegate)_get_delegate();
	try
	{
	    com.ooc.OB.DowncallStub downStub = 
		delegate._OB_getDowncallStub(this);
	    return downStub.getAMIPollTarget();
	}
	catch(com.ooc.OB.LocationForward ex)
	{
	}
	catch(com.ooc.OB.FailureException ex)
	{
	}

	return null;
    }
    
    public com.ooc.OB.ORBInstance
    _OB_get_ami_poll_ORBInstance()
    {
	//
	// We need to be able to retrieve the ORB instance to use with a
	// persistent poller in case we want to use pollable sets
	//
	Delegate delegate = (Delegate)_get_delegate();
	try
	{
	    com.ooc.OB.DowncallStub downStub = 
		delegate._OB_getDowncallStub(this);
	    return downStub._OB_getORBInstance();
	}
	catch(com.ooc.OB.LocationForward ex)
	{
	}
	catch(com.ooc.OB.FailureException ex)
	{
	}

	return null;
    }
    
    public org.omg.MessageRouting.PersistentRequest
    _OB_ami_poll_request(org.omg.CORBA.portable.OutputStream out,
	                 String operation,
			 org.omg.IOP.ServiceContext[] scl)
        throws org.omg.CORBA.portable.RemarshalException
    {
        Delegate delegate = (Delegate)_get_delegate();

        try
        {
            com.ooc.OB.DowncallStub downStub =
                delegate._OB_getDowncallStub(this);
	    org.omg.MessageRouting.PersistentRequest req = 
		downStub.ami_poll_request(out, operation, scl);
	    return req;
        }
        catch(com.ooc.OB.LocationForward ex)
        {
        }
        catch(com.ooc.OB.FailureException ex)
        {
        }

	//
	// Something happened other than what we expected.  Remarshal so
	// the stub can try again.
	//
	throw new org.omg.CORBA.portable.RemarshalException();
    }   
    
    public boolean
    _OB_ami_callback_request(org.omg.CORBA.portable.OutputStream out,
                             org.omg.Messaging.ReplyHandler reply,
			     com.ooc.OCI.ProfileInfo info)
        throws org.omg.CORBA.portable.RemarshalException
    {
        Delegate delegate = (Delegate)_get_delegate();

	boolean success = false; 
        try
        {
            com.ooc.OB.DowncallStub downStub =
                delegate._OB_getDowncallStub(this);
	    success = downStub.ami_callback_request(out, reply, info);
        }
        catch(com.ooc.OB.LocationForward ex)
        {
        }
        catch(com.ooc.OB.FailureException ex)
        {
        }

	return success;
    }   

    public org.omg.Messaging._ExceptionHolder
    _OB_repackageException(java.lang.Exception ex,
	                   boolean system_exception)
    {
	//
	// Create a stream for writing our exception
	//
	com.ooc.OCI.Buffer buf = new com.ooc.OCI.Buffer(32);
	com.ooc.CORBA.OutputStream out = 
	    new com.ooc.CORBA.OutputStream(buf, null, 258);

	//
	// Put the exception into the output stream
	//
	Class exClass = ex.getClass();
	String className = exClass.getName();
	try
	{
	    //
	    // Get the appropriate helper class for the exception and
	    // retrieve the write method from the helper
	    //
	    Class c = Class.forName(className + "Helper");
	    Class[] paramTypes = new Class[2];
	    paramTypes[0] = Class.forName("org.omg.CORBA.portable.OutputStream");
	    paramTypes[1] = Class.forName(className);
	    java.lang.reflect.Method m = c.getMethod("write",
		                                     paramTypes);

	    //
	    // Build up the parameter list
	    //
	    Object[] parameters = new Object[2];
	    parameters[0] = out;
	    parameters[1] = ex;

	    //
	    // No object is needed as the first parameter because the
	    // method is a static method
	    //
	    m.invoke(null, parameters);
	}
	catch(ClassNotFoundException e)
	{
	    //
	    // REVISIT:
	    // This just means that we probably caught a non-CORBA
	    // exception.  For now, just return null.
	    //
	    return null;
	}
	catch(NoSuchMethodException e)
	{
	    com.ooc.OB.Assert._OB_assert(false);
	}
	catch(IllegalAccessException e)
	{
	    com.ooc.OB.Assert._OB_assert(false);
	}
	catch(IllegalArgumentException e)
	{
	    com.ooc.OB.Assert._OB_assert(false);
	}
	catch(java.lang.reflect.InvocationTargetException e)
	{
	    com.ooc.OB.Assert._OB_assert(false);
	}
	catch(SecurityException e)
	{
            //
            // REVISIT:
	    // What to do in this case?
	    // 
	    return null;
	}

        //
	// Now create the exception holder
	//
	com.ooc.OBMessaging.ExceptionHolder_impl exHolder = 
	    new com.ooc.OBMessaging.ExceptionHolder_impl(false,
		                                         system_exception);
	out._OB_pos(0);
	exHolder._OB_extractSequence(out._OB_buffer());
	return exHolder;
    }
}
