// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.DynamicAny;

import com.ooc.CORBA.Any;
import com.ooc.CORBA.TypeCode;
import com.ooc.CORBA.OutputStream;
import com.ooc.CORBA.InputStream;

final class DynArray_impl extends DynSeqBase_impl
    implements org.omg.DynamicAny.DynArray
{
    DynArray_impl(org.omg.DynamicAny.DynAnyFactory factory,
                  com.ooc.OB.ORBInstance orbInstance,
                  org.omg.CORBA.TypeCode type)
    {
        super(factory, orbInstance, type);
    }

    DynArray_impl(org.omg.DynamicAny.DynAnyFactory factory,
                  com.ooc.OB.ORBInstance orbInstance,
                  org.omg.CORBA.TypeCode type,
                  DynValueReader dynValueReader)
    {
        super(factory, orbInstance, type, dynValueReader);
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public synchronized org.omg.CORBA.Any[]
    get_elements()
    {
        return getElements();
    }

    public synchronized void
    set_elements(org.omg.CORBA.Any[] value)
        throws org.omg.DynamicAny.DynAnyPackage.TypeMismatch,
               org.omg.DynamicAny.DynAnyPackage.InvalidValue
    {
        for(int i = 0 ; i < value.length ; i++)
        {
            org.omg.CORBA.TypeCode origTC =
                TypeCode._OB_getOrigType(value[i].type());
            if(origTC.kind() != contentKind_)
                throw new org.omg.DynamicAny.DynAnyPackage.TypeMismatch();
        }

        if(value.length != length_)
            throw new org.omg.DynamicAny.DynAnyPackage.InvalidValue();

        for(int i = 0 ; i < value.length ; i++)
            setValue(i, value[i]);

        index_ = 0;

        notifyParent();
    }

    public synchronized org.omg.DynamicAny.DynAny[]
    get_elements_as_dyn_any()
    {
        return getElementsAsDynAny();
    }

    public synchronized void
    set_elements_as_dyn_any(org.omg.DynamicAny.DynAny[] value)
        throws org.omg.DynamicAny.DynAnyPackage.TypeMismatch,
               org.omg.DynamicAny.DynAnyPackage.InvalidValue
    {
        for(int i = 0 ; i < value.length ; i++)
        {
            org.omg.CORBA.TypeCode origTC =
                TypeCode._OB_getOrigType(value[i].type());
            if(origTC.kind() != contentKind_)
                throw new org.omg.DynamicAny.DynAnyPackage.TypeMismatch();
        }

        if(value.length != length_)
            throw new org.omg.DynamicAny.DynAnyPackage.InvalidValue();

        for(int i = 0 ; i < value.length ; i++)
            setValue(i, value[i]);

        index_ = 0;

        notifyParent();
    }
}
