// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.DynamicAny;

import com.ooc.CORBA.Any;
import com.ooc.CORBA.TypeCode;
import com.ooc.CORBA.OutputStream;
import com.ooc.CORBA.InputStream;

final class DynSequence_impl extends DynSeqBase_impl
    implements org.omg.DynamicAny.DynSequence
{
    DynSequence_impl(org.omg.DynamicAny.DynAnyFactory factory,
                     com.ooc.OB.ORBInstance orbInstance,
                     org.omg.CORBA.TypeCode type)
    {
        super(factory, orbInstance, type);
    }

    DynSequence_impl(org.omg.DynamicAny.DynAnyFactory factory,
                     com.ooc.OB.ORBInstance orbInstance,
                     org.omg.CORBA.TypeCode type,
                     DynValueReader dynValueReader)
    {
        super(factory, orbInstance, type, dynValueReader);
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public synchronized int
    get_length()
    {
        return length_;
    }

    public synchronized void
    set_length(int len)
        throws org.omg.DynamicAny.DynAnyPackage.InvalidValue
    {
        //
        // If bounded sequence, ensure new length is not greater
        // than the bounds
        //
        if(max_ > 0 && len > max_)
            throw new org.omg.DynamicAny.DynAnyPackage.InvalidValue();

        resize(len, true);

        notifyParent();
    }

    public synchronized org.omg.CORBA.Any[]
    get_elements()
    {
        return getElements();
    }

    public synchronized void
    set_elements(org.omg.CORBA.Any[] value)
        throws org.omg.DynamicAny.DynAnyPackage.TypeMismatch,
               org.omg.DynamicAny.DynAnyPackage.InvalidValue
    {
        for(int i = 0 ; i < value.length ; i++)
        {
            org.omg.CORBA.TypeCode tc = value[i].type();
            org.omg.CORBA.TypeCode origTC = TypeCode._OB_getOrigType(tc);
            if(origTC.kind() != contentKind_)
                throw new org.omg.DynamicAny.DynAnyPackage.TypeMismatch();
        }

        resize(value.length, false);

        for(int i = 0 ; i < value.length ; i++)
            setValue(i, value[i]);

        if(value.length == 0)
            index_ = -1;
        else
            index_ = 0;

        notifyParent();
    }

    public synchronized org.omg.DynamicAny.DynAny[]
    get_elements_as_dyn_any()
    {
        return getElementsAsDynAny();
    }

    public synchronized void
    set_elements_as_dyn_any(org.omg.DynamicAny.DynAny[] value)
        throws org.omg.DynamicAny.DynAnyPackage.TypeMismatch,
               org.omg.DynamicAny.DynAnyPackage.InvalidValue
    {
        for(int i = 0 ; i < value.length ; i++)
        {
            org.omg.CORBA.TypeCode tc = value[i].type();
            org.omg.CORBA.TypeCode origTC = TypeCode._OB_getOrigType(tc);
            if(origTC.kind() != contentKind_)
                throw new org.omg.DynamicAny.DynAnyPackage.TypeMismatch();
        }

        resize(value.length, false);

        for(int i = 0 ; i < value.length ; i++)
            setValue(i, value[i]);

        if(value.length == 0)
            index_ = -1;
        else
            index_ = 0;

        notifyParent();
    }
}
