// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.DynamicAny;

import com.ooc.CORBA.Any;
import com.ooc.CORBA.TypeCode;
import com.ooc.CORBA.OutputStream;
import com.ooc.CORBA.InputStream;

abstract class DynValueCommon_impl extends DynAny_impl
    implements org.omg.DynamicAny.DynValueCommon
{
    private boolean isNull_;

    DynValueCommon_impl(org.omg.DynamicAny.DynAnyFactory factory,
                        com.ooc.OB.ORBInstance orbInstance,
                        org.omg.CORBA.TypeCode type)
    {
        super(factory, orbInstance, type);
    }

    // ------------------------------------------------------------------
    // Private and protected member implementations
    // ------------------------------------------------------------------

    protected abstract void
    createComponents();

    protected abstract void
    destroyComponents();

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public synchronized boolean
    is_null()
    {
        return isNull_;
    }

    public synchronized void
    set_to_null()
    {
        if(!isNull_)
        {
            isNull_ = true;
            destroyComponents();
        }
    }

    public synchronized void
    set_to_value()
    {
        if(isNull_)
        {
            isNull_ = false;
            createComponents();
        }
    }
}
