// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.DynamicAny;

import com.ooc.CORBA.TypeCode;
import com.ooc.CORBA.OutputStream;

final public class DynValueWriter
{
    private com.ooc.OB.ORBInstance orbInstance_;
    private org.omg.DynamicAny.DynAnyFactory factory_;
    private DynValueReader dynValueReader_;
    private java.util.Hashtable instanceTable_;

    public DynValueWriter(com.ooc.OB.ORBInstance orbInstance,
                          org.omg.DynamicAny.DynAnyFactory factory)
    {
        orbInstance_ = orbInstance;
        factory_ = factory;
        instanceTable_ = new java.util.Hashtable(131);
        dynValueReader_ = new DynValueReader(orbInstance_, factory_, false);
    }

    public boolean
    writeIndirection(org.omg.DynamicAny.DynAny dv, OutputStream out)
    {
        Integer pos = (Integer)instanceTable_.get(dv);

        if (pos != null)
        {
            com.ooc.OCI.Buffer buf = out._OB_buffer();
            out.write_long(-1);
            int off = pos.intValue() - buf.pos_;
            out.write_long(off);

            return true;
        }
     
        return false;
    }

    public void
    indexValue(org.omg.DynamicAny.DynAny dv, int startPos)
    {
        instanceTable_.put(dv, new Integer(startPos));
        dynValueReader_.indexValue(startPos, dv);
    }

    public DynValueReader
    getReader()
    {
        return dynValueReader_;
    }

}

