// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OAD;

final public class ProcessEndpoint_impl extends ProcessEndpointPOA
{
    private String name_;
    private String id_;
    private org.omg.CORBA.Policy[] pl_;
    private org.omg.PortableServer.POA poa_;
    private com.ooc.OB.ORBControl orbControl_;

    public
    ProcessEndpoint_impl(String name,
    			 String id, 
                         org.omg.PortableServer.POA poa,
			 com.ooc.OB.ORBControl orbControl)
    {
        name_ = name;
	id_ = id;
        poa_ = poa;
	orbControl_ = orbControl;

        //
        // Create a PolicyList for RETRY_ALWAYS
        //
	pl_ = new org.omg.CORBA.Policy[1];
	pl_[0] =
	    new com.ooc.OB.RetryPolicy_impl(com.ooc.OB.RETRY_ALWAYS.value,
	    				    0, 1, false);
    }

    public void
    reestablish_link(ProcessEndpointManager d)
    {
	//
	// Set the retry policy on this object
	//
	org.omg.CORBA.Object obj = d._set_policy_override(
	    pl_, org.omg.CORBA.SetOverrideType.SET_OVERRIDE);
	ProcessEndpointManager manager =
	    ProcessEndpointManagerHelper.narrow(obj);

	ProcessEndpoint cb = _this();

        //
        // Establish a new link with the ProcessEndpointManager
        //
	try
	{
	    manager.establish_link(name_, id_, 0xFFFFFFFF, cb);
	}
	catch(AlreadyLinked ex)
	{
	}
 	catch(org.omg.CORBA.SystemException ex)
	{
	    //logger.error("connect_server failed: " + ex);
	}
    }

    public void
    stop()
    {
        orbControl_.shutdownServer(false);
    }

    public org.omg.PortableServer.POA
    _default_POA()
    {
        return poa_;
    }
}
