// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

final class CodeConverterBoth extends CodeConverterBase
{
    //
    // Unicode character mapping tables
    //
    private CharMapInfo fromMap_;
    private CharMapInfo toMap_;

    // ------------------------------------------------------------------
    // Constructor
    // ------------------------------------------------------------------

    CodeConverterBoth(CodeSetInfo fromSet, CodeSetInfo toSet,
		      CharMapInfo fromMap, CharMapInfo toMap)
    {
        super(fromSet, toSet);

	fromMap_ = fromMap;
	toMap_ = toMap;
    }

    // ------------------------------------------------------------------
    // Public member implementations
    // ------------------------------------------------------------------

    public boolean
    conversionRequired()
    {
	return true;
    }

    public char
    convert(char v)
    {
	if(v <= (char)fromMap_.upper_bound)
	{
	    v = (char)fromMap_.map_values[v];
	}

	for(int i = 0 ; i <= toMap_.upper_bound ; i++)
	{
	    if(toMap_.map_values[i] == v)
		return (char)i;
	}

        return v;
    }
}
