// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

final class CodeConverterFrom extends CodeConverterBase
{
    //
    // Unicode character mapping table
    //
    private CharMapInfo fromMap_;

    // ------------------------------------------------------------------
    // Constructor
    // ------------------------------------------------------------------

    CodeConverterFrom(CodeSetInfo fromSet, CodeSetInfo toSet,
		      CharMapInfo fromMap)
    {
        super(fromSet, toSet);

	fromMap_ = fromMap;
    }

    // ------------------------------------------------------------------
    // Public member implementations
    // ------------------------------------------------------------------

    public boolean
    conversionRequired()
    {
	return true;
    }

    public char
    convert(char v)
    {
	if(v <= (char)fromMap_.upper_bound)
	{
	    return (char)fromMap_.map_values[v];
	}

	return v;
    }
}
