// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

final class CodeConverterNone extends CodeConverterBase
{
    // ------------------------------------------------------------------
    // Constructor
    // ------------------------------------------------------------------

    CodeConverterNone(CodeSetInfo fromSet, CodeSetInfo toSet)
    {
        super(fromSet, toSet);
    }

    // ------------------------------------------------------------------
    // Public member implementations
    // ------------------------------------------------------------------

    public boolean
    conversionRequired()
    {
	return true;
    }

    public char
    read_wchar(com.ooc.CORBA.InputStream in, int len)
    {
        throw new org.omg.CORBA.BAD_PARAM(
            MinorCodes.describeBadParam(MinorCodes.MinorNoWcharCodeSet),
            MinorCodes.MinorNoWcharCodeSet,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    public void
    write_wchar(com.ooc.CORBA.OutputStream out, char v)
    {
        throw new org.omg.CORBA.INV_OBJREF(
            MinorCodes.describeInvObjref(MinorCodes.MinorWcharCodeSetRequired),
            MinorCodes.MinorWcharCodeSetRequired,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    public int
    read_count_wchar(char value)
    {
        throw new org.omg.CORBA.BAD_PARAM(
            MinorCodes.describeBadParam(MinorCodes.MinorNoWcharCodeSet),
            MinorCodes.MinorNoWcharCodeSet,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    public int
    write_count_wchar(char v)
    {
        throw new org.omg.CORBA.INV_OBJREF(
            MinorCodes.describeInvObjref(MinorCodes.MinorWcharCodeSetRequired),
            MinorCodes.MinorWcharCodeSetRequired,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    public char
    convert(char v)
    {
        throw new org.omg.CORBA.INV_OBJREF(
            MinorCodes.describeInvObjref(MinorCodes.MinorWcharCodeSetRequired),
            MinorCodes.MinorWcharCodeSetRequired,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }
}
