// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

final public class CodeConverters
{
    public CodeConverterBase inputCharConverter;
    public CodeConverterBase outputCharConverter;
    public CodeConverterBase inputWcharConverter;
    public CodeConverterBase outputWcharConverter;

    public
    CodeConverters() { }

    public
    CodeConverters(CodeConverters c)
    {
	if(c != null)
	{
	    inputCharConverter = c.inputCharConverter;
	    outputCharConverter = c.outputCharConverter;
	    inputWcharConverter = c.inputWcharConverter;
	    outputWcharConverter = c.outputWcharConverter;
	}
    }

    public boolean
    equals(java.lang.Object obj)
    {
        CodeConverters conv = (CodeConverters)obj;
        if(conv == null)
            return false;

        boolean a = false;
        boolean b = false;
        boolean c = false;
        boolean d = false;

        if(inputCharConverter == null && conv.inputCharConverter == null)
            a = true;
        else if(inputCharConverter != null && 
                inputCharConverter.equals(conv.inputCharConverter))
            a = true;

        if(outputCharConverter == null && conv.outputCharConverter == null)
            b = true;
        else if(outputCharConverter != null &&
                outputCharConverter.equals(conv.outputCharConverter))
            b = true;

        if(inputWcharConverter == null && conv.inputWcharConverter == null)
            c = true;
        else if(inputWcharConverter != null &&
                inputWcharConverter.equals(conv.inputWcharConverter))
            c = true;

        if(outputWcharConverter == null && conv.outputWcharConverter == null)
            d = true;
        else if(outputWcharConverter != null &&
                outputWcharConverter.equals(conv.outputWcharConverter))
            d = true;

        return a && b && c && d;
    }
}
