// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

public interface DowncallEmitter
{
    //
    // Send and receive downcalls
    //
    // - The first parameter is the downcall to send/receive
    //
    // - If the second parameter is set to false, send/receive will be
    //   done non-blocking.
    //
    // - If the return value is true, it's safe to access or modify
    //   the downcall object. If the return value if false, accessing
    //   or modifying the downcall object is not allowed, for thread
    //   safety reasons. (Because the downcall object is not thread
    //   safe.)
    //
    boolean
    send(Downcall down, boolean block);

    boolean
    receive(Downcall down, boolean block);

    //
    // Send and receive downcalls with one operation (for efficiency
    // reasons)
    //
    boolean
    sendReceive(Downcall down);
}
