// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

final class FixedWidth2Reader extends CodeSetReader
{
    public char
    read_char(com.ooc.CORBA.InputStream in)
        throws org.omg.CORBA.DATA_CONVERSION
    {
	//
	// Note: byte must be masked with 0xff to correct negative values
	//
	return (char)(in.buf_.data_[in.buf_.pos_++] & 0xff);
    }

    public char
    read_wchar(com.ooc.CORBA.InputStream in, int len)
        throws org.omg.CORBA.DATA_CONVERSION
    {
	if(len == 2)
	{
	    return (char)((in.buf_.data_[in.buf_.pos_++] << 8) |
			  (in.buf_.data_[in.buf_.pos_++] & 0xff));
	}
	else
	    throw new org.omg.CORBA.DATA_CONVERSION();
    }

    public int
    count_wchar(char value)
    {
	return 2;
    }

    public void
    set_flags(int flags) { }
}
