// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

public interface OAInterface
{
    //
    // Create new Upcall object
    //
    Upcall
    createUpcall(UpcallReturn upcallReturn,
		 com.ooc.OCI.ProfileInfo profileInfo,
		 com.ooc.OCI.TransportInfo transportInfo,
		 int requestId,
		 String op,
		 com.ooc.CORBA.InputStream in,
		 org.omg.IOP.ServiceContext[] requestSCL);

    //
    // Determine if an object with the provided object key exists
    //
    // This enumeration mirrors the GIOP::LocateStatusType_1_2
    //
    int UNKNOWN_OBJECT = 0;
    int OBJECT_HERE = 1;
    int OBJECT_FORWARD = 2;
    int OBJECT_FORWARD_PERM = 3;

    int findByKey(byte[] key, org.omg.IOP.IORHolder ior);

    //
    // Get all profiles that are usable with this OAInterface
    //
    com.ooc.OCI.ProfileInfo[]
    getUsableProfiles(org.omg.IOP.IOR ior,
                      org.omg.CORBA.Policy[] policies);

    //
    // Discard all incoming requests with a TRANSIENT exception
    //
    void discard();

    //
    // Allow associated POAs to receive requests
    //
    void activate();
}
