// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// All connected implementations
//
public class ObjectIdHasher
{
    private byte[] oid_;
    private int hashCode_;
    
    public ObjectIdHasher(byte[] oid)
    {
	oid_ = oid;
	
	hashCode_ = 0;
	int offset = 0;
	int len = oid.length;
	    
	if(len < 16)
	{
	    for(int i = len ; i > 0 ; i--)
		hashCode_ = (hashCode_ * 37) + (int)oid[offset++];
	}
	else
	{
	    int skip = len / 8;
	    for(int i = len ; i > 0 ; i -= skip, offset += skip)
		hashCode_ = (hashCode_ * 39) + (int)oid[offset];
	}
    }

    public byte[]
    getObjectId()
    {
	return oid_;
    }

    public int
    hashCode()
    {
	return hashCode_;
    }
    
    public boolean
    equals(java.lang.Object o)
    {
	ObjectIdHasher h = (ObjectIdHasher)o;
	
	return comp(oid_, h.oid_);
    }
    
    public static boolean
    comp(byte[] id1, byte[] id2)
    {
	if(id1.length != id2.length)
	    return false;

	for(int i = 0 ; i < id1.length ; i++)
	    if(id1[i] != id2[i])
		return false;

	return true;
    }
}
