// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// The data contained in an object key
//
final public class ObjectKeyData
{
    public String serverId; // The Server Id
    public String[] poaId; // The POA to which this key refers
    public byte[] oid; // The object-id to which this key refers
    public boolean persistent; // Is the POA that created this key persistent?
    public int createTime; // If transient, what time was the POA created?

    public ObjectKeyData()
    {
    }

    public ObjectKeyData(String _serverId, 
    			 String[] _poaId,
			 byte[] _oid,
			 boolean _persistent,
		         int _createTime)
    {
        serverId = _serverId;
	poaId = _poaId;
	oid = _oid;
	persistent = _persistent;
	createTime = _createTime;
    }
}
