// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

public class PIArgsDowncall extends PIDowncall
{
    //
    // Argument, result and exception list description provided by the
    // static stubs
    //
    protected ParameterDesc[] argDesc_;
    protected ParameterDesc retDesc_;
    protected org.omg.CORBA.TypeCode[] exceptionTC_;

    // ----------------------------------------------------------------------
    // PIArgsDowncall private and protected member implementations
    // ----------------------------------------------------------------------

    // ----------------------------------------------------------------------
    // PIArgsDowncall public member implementations
    // ----------------------------------------------------------------------

    public
    PIArgsDowncall(ORBInstance orbInstance,
                   Client client,
                   com.ooc.OCI.ProfileInfo profileInfo,
                   RefCountPolicyList policies,
                   String op,
                   boolean resp,
                   org.omg.IOP.IOR IOR,
                   org.omg.IOP.IOR origIOR,
		   /**/ PIManager piManager,
                   ParameterDesc[] argDesc,
                   ParameterDesc retDesc,
                   org.omg.CORBA.TypeCode[] exceptionTC)
    {
        super(orbInstance, client, profileInfo, policies, op, resp, IOR,
              origIOR, piManager);
        argDesc_ = argDesc;
        retDesc_ = retDesc;
        exceptionTC_ = exceptionTC;
    }

    public com.ooc.CORBA.OutputStream
    preMarshal()
        throws LocationForward, FailureException
    {
	requestInfo_ = piManager_.clientSendRequest(op_,
						    responseExpected_,
						    IOR_,
						    origIOR_,
						    profileInfo_,
						    policies_.value,
						    requestSCL_,
						    replySCL_,
						    argDesc_,
						    retDesc_,
						    exceptionTC_);

        return preMarshalBase(); // Equivalent to Downcall::preMarshal()
    }
}
