// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

public class PIDIIDowncall extends PIDowncall
{
    //
    // Argument, result and exception list description provided by the
    // DII
    //
    protected org.omg.CORBA.NVList args_;
    protected org.omg.CORBA.NamedValue result_;
    protected org.omg.CORBA.ExceptionList exceptionList_;

    // ----------------------------------------------------------------------
    // PIDIIDowncall private and protected member implementations
    // ----------------------------------------------------------------------

    // ----------------------------------------------------------------------
    // PIDIIDowncall public member implementations
    // ----------------------------------------------------------------------

    public
    PIDIIDowncall(ORBInstance orbInstance,
                  Client client,
                  com.ooc.OCI.ProfileInfo profileInfo,
                  RefCountPolicyList policies,
                  String op,
                  boolean resp,
                  org.omg.IOP.IOR IOR,
                  org.omg.IOP.IOR origIOR,
		  PIManager piManager,
                  org.omg.CORBA.NVList args,
                  org.omg.CORBA.NamedValue result,
                  org.omg.CORBA.ExceptionList exceptions)
    {
        super(orbInstance, client, profileInfo, policies, op, resp, IOR,
              origIOR, piManager);
        args_ = args;
        result_ = result;
        exceptionList_ = exceptions;
    }

    public com.ooc.CORBA.OutputStream
    preMarshal()
        throws LocationForward, FailureException
    {
	requestInfo_ = piManager_.clientSendRequest(op_,
						    responseExpected_,
						    IOR_,
						    origIOR_,
						    profileInfo_,
						    policies_.value,
						    requestSCL_,
						    replySCL_,
						    args_,
						    result_,
						    exceptionList_);

        return preMarshalBase(); // Equivalent to Downcall::preMarshal()
    }
}
