// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

import java.util.Hashtable;

public final class TypeCodeCache
{
    private Hashtable cache_; // The type code cache hashtable

    static private TypeCodeCache instance_ = null; // Singleton instance
    static private Object instanceMutex_ = new Object();

    // ----------------------------------------------------------------------
    // ORBInstance public member implementation
    // ----------------------------------------------------------------------

    TypeCodeCache()
    {
	cache_ = new Hashtable(63);
    }

    static public TypeCodeCache
    instance()
    {
	if(instance_ == null)
	{
	    synchronized(instanceMutex_)
	    {
		if(instance_ == null)
		{
		    instance_ = new TypeCodeCache();
		}
	    }
	}
	
	return instance_;
    }

    synchronized public com.ooc.CORBA.TypeCode
    get(String id)
    {
	return (com.ooc.CORBA.TypeCode)cache_.get(id);
    }

    synchronized public void
    put(String id, com.ooc.CORBA.TypeCode tc)
    {
	if(cache_.containsKey(id))
	    return;

	cache_.put(id, tc);
    }
}
