// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

class URLUtil
{
    // 
    // Remove URL escape sequences from a string
    // 
    public static String
    unescapeURL(final String str)
    {
        final int len = str.length();
        char[] buf = new char[len];
        int bpos = 0, pos = 0;

        while(pos < len)
        {
            char ch = str.charAt(pos);

            //
            // Escape sequence '%' must be followed by
            // 2 valid characters 0-9, A-F, a-f
            //
            if(ch == '%')
            {
                if(pos + 2 >= len)
                    throw new org.omg.CORBA.BAD_PARAM(
                        MinorCodes.describeBadParam(MinorCodes.MinorBadAddress)
                            + ": bad escape sequence length",
                        MinorCodes.MinorBadAddress, 
                        org.omg.CORBA.CompletionStatus.COMPLETED_NO);

                int c1 = Character.digit(str.charAt(++pos), 16);
                int c2 = Character.digit(str.charAt(++pos), 16);
                
                if(c1 == -1 || c2 == -1)
                    throw new org.omg.CORBA.BAD_PARAM(
                        MinorCodes.describeBadParam(MinorCodes.MinorOther) +
                            ": escape sequence contains invalid characters",
                        MinorCodes.MinorOther,
                        org.omg.CORBA.CompletionStatus.COMPLETED_NO);

                ch = (char)((c1 << 4) | c2);
            }
            buf[bpos++] = ch;
            ++pos;
        }

        return new String(buf, 0, bpos);
    }
}
