// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

final class UTF8Reader extends CodeSetReader
{
    public char
    read_char(com.ooc.CORBA.InputStream in)
        throws org.omg.CORBA.DATA_CONVERSION
    {
	return utf8ToUnicode(in);
    }

    public char
    read_wchar(com.ooc.CORBA.InputStream in, int len)
        throws org.omg.CORBA.DATA_CONVERSION
    {
	return utf8ToUnicode(in);
    }

    public int
    count_wchar(char first)
    {
	if((first & 0x80) == 0)
	    return 1;
	else if((first & 0xf8) == 0xc0)
	    return 2;
	else if((first & 0xf8) == 0xe0)
	    return 3;

	throw new org.omg.CORBA.DATA_CONVERSION();
    }

    private char
    utf8ToUnicode(com.ooc.CORBA.InputStream in)
	throws org.omg.CORBA.DATA_CONVERSION
    {
	byte first = in.buf_.data_[in.buf_.pos_++];

	//
	// Direct mapping for characters < 0x80
	//
	if((first & 0x80) == 0)
	    return (char)first;

	char value;

	if((first & 0xf8) == 0xc0)
	{
	    // 5 free bits
	    value = (char)(first & 0x1f);
	}
	else if((first & 0xf8) == 0xe0)
	{
	    // 4 free bits
	    value = (char)(first & 0x0f);

	    if((in.buf_.data_[in.buf_.pos_] & 0xc0) != 0x80)
		throw new org.omg.CORBA.DATA_CONVERSION();

	    value <<= 6;
	    value |= in.buf_.data_[in.buf_.pos_++] & 0x3f;
	}
	//
	// 16 bit overflow
	//
	else
	    throw new org.omg.CORBA.DATA_CONVERSION();

	if((in.buf_.data_[in.buf_.pos_] & 0xc0) != 0x80)
	    throw new org.omg.CORBA.DATA_CONVERSION();

	value <<= 6;
	value |= in.buf_.data_[in.buf_.pos_++] & 0x3f;

	return value;
    }

    public void
    set_flags(int flags) { }
}
