// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

final class UTF8Writer extends CodeSetWriter
{
    public void
    write_char(com.ooc.CORBA.OutputStream out, char v)
	throws org.omg.CORBA.DATA_CONVERSION
    {
	unicodeToUtf8(out, v);
    }

    public void
    write_wchar(com.ooc.CORBA.OutputStream out, char v)
	throws org.omg.CORBA.DATA_CONVERSION
    {
	unicodeToUtf8(out, v);
    }

    public int
    count_wchar(char value)
    {
	if(value < 0x80)
	    return 1;
	else if(value < 0x7ff)
	    return 2;
	else
	    return 3;
    }

    private void
    unicodeToUtf8(com.ooc.CORBA.OutputStream out, char value)
	throws org.omg.CORBA.DATA_CONVERSION
    {
        if(OB_Extras.COMPAT_WIDE_MARSHAL == true)
        {
    	    if((int)value < 0x80)
    	    {
	        // Direct mapping (7 bits) for characters < 0x80
	        out.buf_.data_[out.buf_.pos_++] = (byte)value;
    	    }
	    else if((int)value < 0x7ff)
	    {
	        // 5 free bits (%110xxxxx | %vvvvv)
	        out.buf_.data_[out.buf_.pos_++] = (byte)((value >>> 6) | 0xc0);
	        out.buf_.data_[out.buf_.pos_++] = (byte)(value & 0x3f);
	    }
	    else if((int)value < 0xffff)
	    {
	        // 4 free bits (%1110xxxx | %vvvv)
	        out.buf_.data_[out.buf_.pos_++] = (byte)((value >>> 12) | 0xe0);
	        out.buf_.data_[out.buf_.pos_++] =
		    (byte)(((value >>> 6) & 0x3f) | 0x80);
	        out.buf_.data_[out.buf_.pos_++] = (byte)((value & 0x3f) | 0x80);
	    }
	    else
	        throw new org.omg.CORBA.DATA_CONVERSION();
        }
        else
        {
    	    if((int)value < 0x80)
    	    {
	        // Direct mapping (7 bits) for characters < 0x80
	        out.buf_.data_[out.buf_.pos_++] = (byte)value;
    	    }
	    else if((int)value <= 0x7ff)
	    {
	        // 5 free bits (%110xxxxx | %vvvvv)
	        out.buf_.data_[out.buf_.pos_++] = (byte)((value >>> 6) | 0xc0);
	        out.buf_.data_[out.buf_.pos_++] = (byte)((value & 0x3f) | 0x80);
	    }
	    else if((int)value <= 0xffff)
	    {
	        // 4 free bits (%1110xxxx | %vvvv)
	        out.buf_.data_[out.buf_.pos_++] = (byte)((value >>> 12) | 0xe0);
	        out.buf_.data_[out.buf_.pos_++] =
		    (byte)(((value >>> 6) & 0x3f) | 0x80);
	        out.buf_.data_[out.buf_.pos_++] = (byte)((value & 0x3f) | 0x80);
	    }
	    else
	        throw new org.omg.CORBA.DATA_CONVERSION();
        }
    }

    public void
    set_flags(int flags) { }
}
