// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

public final class Version
{
    //
    // The ORBacus version, as string and as integer
    //
    // Format of integer_version: ABBCCDD
    //
    // For regular releases (that is non-beta and non-alpha), A is the
    // major version, BB the minor version, CC the patchlevel version, and
    // DD is 00. Examples:
    //
    //                      ABBCCDD
    // Version 3.2          3020000L
    // Version 3.2.4        3020400L
    // Version 4.0          4000000L
    // Version 4.0.1        4000100L
    //
    // For alpha and beta releases, 1 must be substracted from ABBCC. For
    // alpha releases, DD is then the alpha release number. For beta
    // releases, DD is the beta release number plus 50. Examples:
    //
    //                         ABBCCDD
    // Version 3.2a1           3019901L
    // Version 3.2.4b2         3020352L
    // Version 4.0b1           3999951L
    // Version 4.0.1a1         4000001L
    //
    static public final String version = "4.3.1";
    static public final int integer_version = 4030100;
    static public final String special_version_tag = "GA Release";
    
    public static void
    main(String[] args)
    {
        System.out.println("Orbacus for Java " + version +
                           " [" + special_version_tag + "]");
    }
}
