// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OBMessaging;

public class Poller_impl implements org.omg.CORBA.Pollable, 
                                    org.omg.Messaging.Poller
{
    //
    // ORBInstance this poller is bound to
    //
    protected com.ooc.OB.ORBInstance orbInstance_ = null;

    //
    // operation target
    //
    protected org.omg.CORBA.Object objectTarget_ = null;

    //
    // Operation name
    //
    protected String operationName_ = null;

    //
    // Associated ReplyHandler
    //
    protected org.omg.Messaging.ReplyHandler replyHandler_ = null;

    // ----------------------------------------------------------------
    // Standard IDL to Java mapping
    // ----------------------------------------------------------------
    public String[]
    _truncatable_ids()
    {
        throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    // ----------------------------------------------------------------
    // From org.omg.CORBA.Pollable
    // ----------------------------------------------------------------

    //
    // IDL:omg.org/CORBA/Pollable/is_ready:1.0
    //
    public boolean 
    is_ready(int timeout)
    {
        com.ooc.OB.Assert._OB_assert(orbInstance_ != null);
        
        com.ooc.OB.OrbAsyncHandler handler =
            orbInstance_.getAsyncHandler();
        return handler.is_ready(this, timeout);
    }

    //
    // IDL:omg.org/CORBA/Pollable/create_pollable_set:1.0
    //
    public org.omg.CORBA.PollableSet 
    create_pollable_set()
    {
        com.ooc.OB.Assert._OB_assert(orbInstance_ != null);
        
        return new com.ooc.OBCORBA.PollableSet_impl();
    }

    // ----------------------------------------------------------------
    // From org.omg.Messaging.Poller
    // ----------------------------------------------------------------

    //
    // IDL:omg.org/Messaging/Poller/operation_target:1.0
    //
    public org.omg.CORBA.Object 
    operation_target()
    {
        return objectTarget_;
    }

    //
    // IDL:omg.org/Messaging/Poller/operation_name:1.0
    //
    public String 
    operation_name()
    {
        return operationName_;
    }

    //
    // IDL:omg.org/Messaging/Poller/associated_handler:1.0
    //
    public org.omg.Messaging.ReplyHandler 
    associated_handler()
    {
        return replyHandler_;
    }

    public void 
    associated_handler(org.omg.Messaging.ReplyHandler handler)
    {
        replyHandler_ = handler;
    }

    //
    // IDL:omg.org/Messasging/Poller/is_from_poller:1.0
    //
    public boolean 
    is_from_poller()
    {
        return false;
    }

    // ----------------------------------------------------------------
    // Proprietary methods used by the ORB
    // ----------------------------------------------------------------
    
    //
    // set the internal ORBInstance handle
    // 
    public void 
    _OB_ORBInstance(com.ooc.OB.ORBInstance orb)
    {
        orbInstance_ = orb;
    }

    //
    // set the object target reference in this poller
    //
    public void 
    _OB_Object(org.omg.CORBA.Object obj)
    {
        objectTarget_ = obj;
    }

    //
    // get the response of this request
    //
    public com.ooc.OB.Downcall
    _OB_poll_response()
    {
        com.ooc.OB.OrbAsyncHandler handler = orbInstance_.getAsyncHandler();
        return handler.poll_response(this);
    }
}
