// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OBMessaging;

public class UserExceptionRaiseProxy
{
    public void 
    raise(org.omg.Messaging._ExceptionHolder execptHolder)
        throws org.omg.CORBA.UserException
    {
    }

    public void 
    raise_with_list(org.omg.Messaging._ExceptionHolder exceptHolder,
	            org.omg.CORBA.TypeCode[] exceptList)
        throws org.omg.CORBA.UserException
    {
        try
	{
	    raise(exceptHolder);
	}
	catch(org.omg.CORBA.UserException ex)
	{
            org.omg.CORBA.Any any = new com.ooc.CORBA.Any();

            Class exClass = ex.getClass();
            String className = exClass.getName();
            try
            {
                //
                // Get the helper class and the insert method with
                // appropriate parameter types
                //
                Class c = Class.forName(className + "Helper");
                Class[] paramTypes = new Class[2];
                paramTypes[0] = Class.forName("org.omg.CORBA.Any");
                paramTypes[1] = Class.forName(className);
                java.lang.reflect.Method m = c.getMethod("insert",
                                                         paramTypes);

                //
                // Build up the parameter list
                //
                Object[] parameters = new Object[2];
                parameters[0] = any;
                parameters[1] = ex;

                //
                // No object is needed since this is a static method
                // call
                //
                m.invoke(null, parameters);
            }
            catch(ClassNotFoundException e)
            {
                //
                // REVISIT:
                // This just means that we probably caught a non-CORBA
                // exception.  For now, we'll just throw this again.
                //
                //throw e;
            }
            catch(NoSuchMethodException e)
            {
                com.ooc.OB.Assert._OB_assert(false);
            }
            catch(IllegalAccessException e)
            {
                com.ooc.OB.Assert._OB_assert(false);
            }
            catch(IllegalArgumentException e)
            {
                com.ooc.OB.Assert._OB_assert(false);
            }
            catch(java.lang.reflect.InvocationTargetException e)
            {
                com.ooc.OB.Assert._OB_assert(false);
            }
            catch(SecurityException e)
            {
		//
		// REVISIT:
		// What do we do here?
		//
            }
	   	    
	    for(int i = 0; i < exceptList.length; ++i)
	    {
		if(any.type().equal(exceptList[i]))
		    throw ex;
	    }
	}
    }

    public void 
    register_as_proxy_with(org.omg.Messaging._ExceptionHolder exceptHolder)
    {

	com.ooc.OBMessaging.ExceptionHolder_impl exImpl = 
	    (com.ooc.OBMessaging.ExceptionHolder_impl)exceptHolder;

	exImpl._OB_register_raise_proxy(this);
	//
	// TODO: try/catch block???
	//
	/*
        com.ooc.OBMessaging.ExceptionHolder_impl exImpl = 
	    (com.ooc.OBMessaging.ExceptionHolder_impl)exceptHolder;

	exImpl._OB_register_raise_proxy(this);
	*/
    }
}
