// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OBPortableInterceptor;

//
// The IMR ObjectReferenceTemplate
//
final public class IMRORT_impl extends IMRORT
{
    // ------------------------------------------------------------------
    // Public member implementations
    // ------------------------------------------------------------------

    public
    IMRORT_impl()
    {
    }

    public
    IMRORT_impl(
        String serverId,
        String[] adapterName,
   	org.omg.PortableInterceptor.ObjectReferenceTemplate realTemplate)
    {
        the_server_id = serverId;
        the_adapter_name = adapterName;
	the_real_template = realTemplate;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java mapping
    // ------------------------------------------------------------------

    public String
    server_id()
    {
        return the_real_template.server_id();
    }

    public String
    orb_id()
    {
        return the_real_template.orb_id();
    }

    public String[]
    adapter_name()
    {
        return the_real_template.adapter_name();
    }

    public org.omg.CORBA.Object
    make_object(String repoid, byte[] id)
    {
        //
	// Create the ORBacus IMR ObjectKey
	//
        String[] poaId = the_adapter_name;

	com.ooc.OB.ObjectKeyData obkey = new com.ooc.OB.ObjectKeyData();
	obkey.serverId = the_server_id;
	obkey.poaId = new String[poaId.length];
	System.arraycopy(poaId, 0, obkey.poaId, 0, poaId.length);
	obkey.oid = id;
	obkey.persistent = true;
	obkey.createTime = 0;

	//
	// CreatePersistentObjectKey/CreateTransientObjectKey instead of
	// populating this ObjectKey data to avoid the copy?
	//
	byte[] key = com.ooc.OB.ObjectKey.CreateObjectKey(obkey);

	//
	// Create and return reference using the real template
	//
	return the_real_template.make_object(repoid, key);
    }
}
