// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OBPortableServer;

class DefaultServantHolder
{
    private boolean destroyed_;

    org.omg.PortableServer.Servant servant_;

    //
    // Destroy the default servant
    //
    synchronized void
    destroy()
    {
	servant_ = null;
    }

    //
    // Set the default servant
    //
    synchronized public void
    setDefaultServant(org.omg.PortableServer.Servant servant)
    {
	servant_ = servant;
    }

    //
    // Retrieve the default servant
    //
    synchronized public org.omg.PortableServer.Servant
    getDefaultServant()
    {
	return servant_;
    }

    //
    // Retrieve the ObjectId associated with the servant, if necessary
    //
    synchronized byte[]
    servantToId(org.omg.PortableServer.Servant servant,
		com.ooc.PortableServer.Current_impl poaCurrent)
    {
	if(servant != servant_)
	    return null;
	
	if(poaCurrent._OB_inUpcall() &&
	   poaCurrent._OB_getServant() == servant)
	{
	    try
	    {
		return poaCurrent.get_object_id();
	    }
	    catch(org.omg.PortableServer.CurrentPackage.NoContext ex)
	    {
		com.ooc.OB.Assert._OB_assert(false); // TODO: Internal error
	    }
	}
	return null;
    }
}
