// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OBPortableServer;

//
// Note: We cannot use String[] as a Hashtable key, because
// different hashcodes are computed for equivalent string arrays.
//
final class POANameHasher
{
    private String[] poaId_;
    private int hashCode_;
    
    POANameHasher(String[] poaId)
    {
	poaId_ = poaId;
	hashCode_ = ("").hashCode();
	for(int i = 0 ; i < poaId_.length ; i++)
	    hashCode_ ^= poaId_[i].hashCode();
    }
    
    public int
    hashCode()
    {
	return hashCode_;
    }
    
    public boolean
    equals(java.lang.Object o)
    {
	POANameHasher k = (POANameHasher)o;
	
	if(poaId_.length != k.poaId_.length)
	    return false;
	
	for(int i = 0 ; i < poaId_.length ; i++)
	    if(!poaId_[i].equals(k.poaId_[i]))
		return false;
	
	return true;
    }
}

