// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OBPortableServer;

interface ServantLocationStrategy
{
    //
    // Destroy the ServantLocatioStrategy
    //
    void
    destroy(org.omg.PortableServer.POA poa, boolean etherealize);

    //
    // Etherealize the ServantLocatioStrategy
    //
    void
    etherealize(org.omg.PortableServer.POA poa);

    //
    // Register the servant with the ObjectId
    //
    void
    activate(byte[] oid, org.omg.PortableServer.Servant servant)
	throws org.omg.PortableServer.POAPackage.ServantAlreadyActive,
	      org.omg.PortableServer.POAPackage.WrongPolicy,
              org.omg.PortableServer.POAPackage.ObjectAlreadyActive;

    //
    // Unregister the servant with the ObjectId
    //
    void
    deactivate(org.omg.PortableServer.POA poa, byte[] oid)
	throws org.omg.PortableServer.POAPackage.ObjectNotActive,
               org.omg.PortableServer.POAPackage.WrongPolicy;


    //
    // Return the ObjectId associated with the Servant
    //
    byte[]
    servantToId(org.omg.PortableServer.Servant servant,
		com.ooc.PortableServer.Current_impl poaCurrent);

    //
    // Return the Servant associated with the ObjectId
    //
    org.omg.PortableServer.Servant
    idToServant(byte[] oid, boolean useDefaultServant);

    //
    // Locate the servant with the ObjectId
    //
    org.omg.PortableServer.Servant
    locate(byte[] oid, org.omg.PortableServer.POA poa,
	   String op,
	   org.omg.PortableServer.ServantLocatorPackage.CookieHolder cookie)
        throws com.ooc.OB.LocationForward;

    //
    // About to call a method on the Servant
    //
    void
    preinvoke(byte[] oid);

    //
    // Completed calling a method on the Servant
    //
    void
    postinvoke(byte[] oid, org.omg.PortableServer.POA poa,
	       String op, java.lang.Object cookie,
	       org.omg.PortableServer.Servant servant);

    //
    // Create a DirectStubImpl for the ObjectId
    //
    DirectServant
    createDirectStubImpl(org.omg.PortableServer.POA poa, byte[] oid,
    			 com.ooc.OB.RefCountPolicyList policies)
        throws com.ooc.OB.LocationForward;

    //
    // Destroy a DirectStubImpl for the ObjectId
    //
    void
    removeDirectStubImpl(byte[] oid, DirectServant directServant);

    //
    // Retrieve the servant manager strategy
    //
    ServantManagerStrategy
    getServantManagerStrategy();

    //
    // Retrieve the default servant holder
    //
    DefaultServantHolder
    getDefaultServantHolder();
}
