// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI.IIOP;

public final class ListenerMap
{
    //
    // Internal list of ListenPoints
    // 
    private java.util.LinkedList list_ = new java.util.LinkedList();

    //
    // adds a new endpoint to the internal list
    // 
    public void add(String host, short port)
    {
        //
        // first make sure we don't already have this host/port in our
        // list
        // 
        java.util.ListIterator i = list_.listIterator(0);
        while(i.hasNext())
        {
            org.omg.IIOP.ListenPoint lp = 
                (org.omg.IIOP.ListenPoint)i.next();

            if(match(lp, host, port))
                return;
        }

        // 
        // we are now free to add this item
        //
        org.omg.IIOP.ListenPoint lp = 
            new org.omg.IIOP.ListenPoint(host, port);
        list_.add(lp);
    }

    // 
    // removes an endpoint from the internal list
    // 
    public void remove(String host, short port)
    {
        java.util.ListIterator i = list_.listIterator(0);
        while(i.hasNext())
        {
            org.omg.IIOP.ListenPoint lp = 
                (org.omg.IIOP.ListenPoint)i.next();
            if(match(lp, host, port))
            {
                i.remove();
                return;
            }
        }
    }

    // 
    // checks if a ListenPoint is equal to the specified host/port
    // 
    public boolean match(org.omg.IIOP.ListenPoint lp,
                         String host, short port)
    {
        if(lp.port != port)
            return false;

        if(host.equals(lp.host))
            return true;

        return false;
    }

    // 
    // returns an array of ListenPoints from this ListenerMap
    //
    public org.omg.IIOP.ListenPoint[] getListenPoints()
    {
        org.omg.IIOP.ListenPoint[] lpl = 
            new org.omg.IIOP.ListenPoint[list_.size()];

        int i = 0;
        java.util.ListIterator itor = list_.listIterator();
        while(itor.hasNext())
        {
            lpl[i++] = (org.omg.IIOP.ListenPoint)itor.next();
        }
        
        return lpl;
    }
}
