// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.PortableInterceptor;

final class ArgumentStrategyNull extends ArgumentStrategy
{
    ArgumentStrategyNull(org.omg.CORBA.ORB orb)
    {
        super(orb);
    }

    //
    // Get the arguments
    //
    org.omg.Dynamic.Parameter[]
    arguments()
    {
        if(!argsAvail_)
            throw new org.omg.CORBA.BAD_INV_ORDER(
                com.ooc.OB.MinorCodes.describeBadInvOrder(
                    com.ooc.OB.MinorCodes.MinorInvalidPICall) +
                    ": arguments unavailable",
                com.ooc.OB.MinorCodes.MinorInvalidPICall,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);

        throw new org.omg.CORBA.NO_RESOURCES(
                com.ooc.OB.MinorCodes.describeNoResources(
                    com.ooc.OB.MinorCodes.MinorInvalidBinding) +
                    ": arguments unavailable",
                com.ooc.OB.MinorCodes.MinorInvalidBinding,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    //
    // Get the exceptions
    //
    org.omg.CORBA.TypeCode[]
    exceptions()
    {
        if(!exceptAvail_)
            throw new org.omg.CORBA.BAD_INV_ORDER(
                com.ooc.OB.MinorCodes.describeBadInvOrder(
                    com.ooc.OB.MinorCodes.MinorInvalidPICall) +
                    ": exceptions unavailable",
                com.ooc.OB.MinorCodes.MinorInvalidPICall,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);

        throw new org.omg.CORBA.NO_RESOURCES(
                com.ooc.OB.MinorCodes.describeNoResources(
                    com.ooc.OB.MinorCodes.MinorInvalidBinding) +
                    ": exceptions unavailable",
                com.ooc.OB.MinorCodes.MinorInvalidBinding,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    //
    // Get the result
    //
    org.omg.CORBA.Any
    result()
    {
        if(!resultAvail_)
            throw new org.omg.CORBA.BAD_INV_ORDER(
                com.ooc.OB.MinorCodes.describeBadInvOrder(
                    com.ooc.OB.MinorCodes.MinorInvalidPICall) +
                    ": result unavailable",
                com.ooc.OB.MinorCodes.MinorInvalidPICall,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);

        throw new org.omg.CORBA.NO_RESOURCES(
                com.ooc.OB.MinorCodes.describeNoResources(
                    com.ooc.OB.MinorCodes.MinorInvalidBinding) +
                    ": result unavailable",
                com.ooc.OB.MinorCodes.MinorInvalidBinding,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    //
    // Set the result (server side only)
    //
    void
    setResult(org.omg.CORBA.Any any)
    {
        com.ooc.OB.Assert._OB_assert(false);
    }
}
