// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.IMR;

//
// IDL:ooc.com/IMR/ActiveState:1.0
//
/***/

public interface ActiveStateOperations
{
    //
    // IDL:ooc.com/IMR/ActiveState/set_status:1.0
    //
    /**
     *
     * Called to update the server status
     *
     * @param id The server id
     * @param status The new server status
     *
     **/

    void
    set_status(String id,
               ServerStatus status);

    //
    // IDL:ooc.com/IMR/ActiveState/poa_create:1.0
    //
    /**
     *
     * Called when a POA is created
     *
     * @param state The POA state
     * @param poa_tmpl The POAs ORT
     * @return The IMRs ORT
     *
     * @exception com.ooc.IMR._NoSuchPOA If a record for the POA does not exist
     *
     **/

    org.omg.PortableInterceptor.ObjectReferenceTemplate
    poa_create(POAStatus state,
               org.omg.PortableInterceptor.ObjectReferenceTemplate poa_tmpl)
        throws _NoSuchPOA;

    //
    // IDL:ooc.com/IMR/ActiveState/poa_status_update:1.0
    //
    /**
     *
     * Called when POA Manager changes state.
     *
     * @param poas List of affected POAs
     * @param state The POA Manager state
     *
     **/

    void
    poa_status_update(String[][] poas,
                      POAStatus state);
}
