// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.IMR;

//
// IDL:ooc.com/IMR/Domain:1.0
//
/***/

public interface DomainOperations
{
    //
    // IDL:ooc.com/IMR/Domain/registerServer:1.0
    //
    /**
     *
     * Called for automatic server registration
     *
     * @param name The server name
     * @param exec The server executable path
     * @param host The server host name
     *
     * @return Whether an entry already existed
     *
     **/

    void
    registerServer(String name,
                   String exec,
                   String host)
        throws ServerAlreadyRegistered;

    //
    // IDL:ooc.com/IMR/Domain/startup:1.0
    //
    /**
     *
     * Called to inform the IMR that the server has been started
     *
     * @param serverId The server id
     * @param instance The server instance
     * @param root_tmpl The RootPOA ORT
     * @param endpoint The ProcessControllerRegistrar for the process
     *
     **/

    ActiveState
    startup(String serverId,
            String instance,
            org.omg.PortableInterceptor.ObjectReferenceTemplate root_tmpl,
            com.ooc.OAD.ProcessEndpointManagerHolder endpoint)
        throws NoSuchServer,
               NoSuchOAD,
               OADNotRunning;
}
