// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.IMR;

//
// IDL:ooc.com/IMR/POAAlreadyRegistered:1.0
//
/**
 *
 * A POAAlreadyRegistered exception indicates that the POA detailed in
 * the member <code>poa</code> doesn't exist in the server specified
 * in in the member <code>name</code>.
 *
 **/

final public class POAAlreadyRegistered extends org.omg.CORBA.UserException
{
    private static final String _ob_id = "IDL:ooc.com/IMR/POAAlreadyRegistered:1.0";

    public
    POAAlreadyRegistered()
    {
        super(_ob_id);
    }

    public
    POAAlreadyRegistered(String name,
                         String[] poa)
    {
        super(_ob_id);
        this.name = name;
        this.poa = poa;
    }

    public
    POAAlreadyRegistered(String _reason,
                         String name,
                         String[] poa)
    {
        super(_ob_id + " " + _reason);
        this.name = name;
        this.poa = poa;
    }

    public String name;
    public String[] poa;
}
