// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.IMR;

//
// IDL:ooc.com/IMR/ServerDomain:1.0
//
/***/

public interface ServerDomainOperations extends DomainOperations
{
    //
    // IDL:ooc.com/IMR/ServerDomain/get_server_factory:1.0
    //
    /**
     *
     * Retrieve the Server Factory.
     *
     * @return The reference to the server factory.
     *
     **/

    ServerFactory
    get_server_factory();

    //
    // IDL:ooc.com/IMR/ServerDomain/create_oad_record:1.0
    //
    /**
     *
     * Create OAD record.
     *
     * @param host The host name
     *
     **/

    void
    create_oad_record(String host)
        throws OADAlreadyExists;

    //
    // IDL:ooc.com/IMR/ServerDomain/remove_oad_record:1.0
    //
    /**
     *
     * Remove an OAD record.
     *
     * @param host The OAD's host
     *
     **/

    void
    remove_oad_record(String host)
        throws NoSuchOAD,
               OADRunning;

    //
    // IDL:ooc.com/IMR/ServerDomain/get_oad_record:1.0
    //
    /**
     *
     * Retrieve an OAD record.
     *
     * @param host The OAD's host
     *
     * @return The OAD record.
     *
     **/

    OADInfo
    get_oad_record(String host)
        throws NoSuchOAD;

    //
    // IDL:ooc.com/IMR/ServerDomain/list_oads:1.0
    //
    /**
     *
     * List the Object Activation Daemons.
     *
     * @return A sequence of OADInfo's.
     *
     **/

    OADInfo[]
    list_oads();
}
