// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.IMR;

//
// IDL:ooc.com/IMR/ServerFactory:1.0
//
/***/

public interface ServerFactoryOperations
{
    //
    // IDL:ooc.com/IMR/ServerFactory/get_server:1.0
    //
    /**
     *
     * Retrieve a server record.
     *
     * @param server The server name
     *
     * @return The server record.
     *
     **/

    Server
    get_server(String server)
        throws NoSuchServer;

    //
    // IDL:ooc.com/IMR/ServerFactory/create_server_record:1.0
    //
    /**
     *
     * Create server record.
     *
     * @param server The server name
     *
     * @return The ID of the created server
     *
     **/

    Server
    create_server_record(String server)
        throws ServerAlreadyRegistered;

    //
    // IDL:ooc.com/IMR/ServerFactory/list_servers:1.0
    //
    /**
     *
     * List all the server records.
     *
     * @return A sequence of server records.
     *
     **/

    Server[]
    list_servers();

    //
    // IDL:ooc.com/IMR/ServerFactory/list_servers_by_host:1.0
    //
    /**
     *
     * List the server records for a particular OAD/Host.
     *
     * @return A sequence of server records.
     *
     **/

    Server[]
    list_servers_by_host(String host);

    //
    // IDL:ooc.com/IMR/ServerFactory/list_orphaned_servers:1.0
    //
    /**
     *
     * List the orphaned server records.
     *
     * @return A sequence of server records.
     *
     **/

    Server[]
    list_orphaned_servers();
}
