// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.IMR;

//
// IDL:ooc.com/IMR/Server:1.0
//
/**
 *
 * The Server interface.
 *
 **/

public interface ServerOperations
{
    //
    // IDL:ooc.com/IMR/Server/id:1.0
    //
    /** The server id. */

    int
    id();

    //
    // IDL:ooc.com/IMR/Server/status:1.0
    //
    /** The server status. */

    ServerStatus
    status();

    //
    // IDL:ooc.com/IMR/Server/manual:1.0
    //
    /** Was this process manually started? */

    boolean
    manual();

    //
    // IDL:ooc.com/IMR/Server/updateTime:1.0
    //
    /** The last update time. */

    int
    updateTime();

    //
    // IDL:ooc.com/IMR/Server/timesForked:1.0
    //
    /** The number of times restarted. */

    short
    timesForked();

    //
    // IDL:ooc.com/IMR/Server/name:1.0
    //
    /** The server name. */

    String
    name();

    void
    name(String val);

    //
    // IDL:ooc.com/IMR/Server/host:1.0
    //
    /** The server host. */

    String
    host();

    void
    host(String val);

    //
    // IDL:ooc.com/IMR/Server/exec:1.0
    //
    /** The exec string for the server. */

    String
    exec();

    void
    exec(String val);

    //
    // IDL:ooc.com/IMR/Server/args:1.0
    //
    /** The server's command-line arguments. */

    String[]
    args();

    void
    args(String[] val);

    //
    // IDL:ooc.com/IMR/Server/directory:1.0
    //
    /** The server's runtime directory. */

    String
    directory();

    void
    directory(String val);

    //
    // IDL:ooc.com/IMR/Server/mode:1.0
    //
    /** The server mode */

    ServerActivationMode
    mode();

    void
    mode(ServerActivationMode val);

    //
    // IDL:ooc.com/IMR/Server/updateTimeout:1.0
    //
    /** The update timeout. */

    int
    updateTimeout();

    void
    updateTimeout(int val);

    //
    // IDL:ooc.com/IMR/Server/failureTimeout:1.0
    //
    /** The failure timeout. */

    int
    failureTimeout();

    void
    failureTimeout(int val);

    //
    // IDL:ooc.com/IMR/Server/maxForks:1.0
    //
    /** The maximum number of forks. */

    short
    maxForks();

    void
    maxForks(short val);

    //
    // IDL:ooc.com/IMR/Server/activatePOAs:1.0
    //
    /** Allow implicit POA activation. */

    boolean
    activatePOAs();

    void
    activatePOAs(boolean val);

    //
    // IDL:ooc.com/IMR/Server/create_poa_record:1.0
    //
    /**
     *
     * Create a POA record.
     *
     * @param poa The POA to create
     *
     **/

    void
    create_poa_record(String[] poa)
        throws POAAlreadyRegistered;

    //
    // IDL:ooc.com/IMR/Server/remove_poa_record:1.0
    //
    /**
     *
     * Remove a POA record.
     *
     * @param poa The POA to remove
     *
     **/

    void
    remove_poa_record(String[] poa)
        throws _NoSuchPOA;

    //
    // IDL:ooc.com/IMR/Server/get_poa_info:1.0
    //
    /**
     *
     * Retrieve POA info record.
     *
     * @param poa The POA name
     *
     * @return The POA info record.
     *
     **/

    POAInfo
    get_poa_info(String[] poa)
        throws _NoSuchPOA;

    //
    // IDL:ooc.com/IMR/Server/list_poas:1.0
    //
    /**
     *
     * List the poas.
     *
     * @return A sequence of poa names.
     *
     **/

    POAInfo[]
    list_poas();

    //
    // IDL:ooc.com/IMR/Server/clear_error_state:1.0
    //
    /**
     *
     * Clear the servers error state
     *
     **/

    void
    clear_error_state();

    //
    // IDL:ooc.com/IMR/Server/start:1.0
    //
    /**
     *
     * Start the server, if not running.
     *
     **/

    void
    start()
        throws ServerRunning;

    //
    // IDL:ooc.com/IMR/Server/stop:1.0
    //
    /**
     *
     * Stop the server, if running.
     *
     **/

    void
    stop()
        throws OADNotRunning,
               ServerNotRunning;

    //
    // IDL:ooc.com/IMR/Server/destroy:1.0
    //
    /**
     *
     * Destroy the server record.
     *
     **/

    void
    destroy()
        throws ServerRunning;
}
