// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OAD;

//
// IDL:ooc.com/OAD/ProcessEndpointManager:1.0
//
/**
 *
 * The ProcessEndpointManager. This endpoint tracks links
 * between the ProcessManager and spawned processes
 *
 **/

public interface ProcessEndpointManagerOperations
{
    //
    // IDL:ooc.com/OAD/ProcessEndpointManager/establish_link:1.0
    //
    /**
     *
     * Called by the Process to establish a link between the Process
     * and the ProcessManager
     *
     * @param server The server name
     * @param instance The Server Instance ID
     * @param pid The Server Process ID
     * @param endpoint The ProcessEndpoint
     *
     * @exception com.ooc.OAD.AlreadyLinked Thrown if the process is already linked
     *
     **/

    void
    establish_link(String server,
                   String id,
                   int pid,
                   ProcessEndpoint endpoint)
        throws AlreadyLinked;
}
