// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OAD;

//
// IDL:ooc.com/OAD/ProcessEndpoint:1.0
//
/**
 *
 * The ProcessEndpoint. This is used to reestablish a link between
 * the ProcessManager and the Process
 *
 **/

public interface ProcessEndpointOperations
{
    //
    // IDL:ooc.com/OAD/ProcessEndpoint/reestablish_link:1.0
    //
    /**
     *
     * Called by the ProcessManager to establish a link between the
     * Process and the ProcessManager
     *
     * @param endpoint The ProcessEndpointManager with which to establish
     *                  a link
     **/

    void
    reestablish_link(ProcessEndpointManager endpoint);

    //
    // IDL:ooc.com/OAD/ProcessEndpoint/stop:1.0
    //
    /**
     *
     * Called by the ProcessManager to inform the Process to shutdown.
     *
     **/

    void
    stop();
}
