// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/BootLocator:1.0
//
/**
 *
 * Interface used by BootManager to assist in locating objects.
 *
 * @see BootManager
 * 
 **/

public interface BootLocatorOperations
{
    //
    // IDL:ooc.com/OB/BootLocator/locate:1.0
    //
    /**
     *
     * Locate the object coresponding to the given object id.
     *
     * @param oid The object id.
     *
     * @param obj The object reference to associate with the id.
     *
     * @param add Whether the binding should be added to the internal
     * table.
     *
     * @exception NotFound Raised if no binding found.
     *
     **/

    void
    locate(byte[] oid,
           org.omg.CORBA.ObjectHolder obj,
           org.omg.CORBA.BooleanHolder add)
        throws com.ooc.OB.BootManagerPackage.NotFound;
}
