// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/BootManager:1.0
//
/**
 *
 * Interface to manage bootstrapping of objects.
 * 
 **/

public interface BootManagerOperations
{
    //
    // IDL:ooc.com/OB/BootManager/add_binding:1.0
    //
    /**
     *
     * Add a new binding to the internal table.
     *
     * @param oid The object id to bind.
     *
     * @param obj The object reference.
     *
     * @exception com.ooc.OB.BootManagerPackage.AlreadyExists Thrown if binding already exists.
     *
     **/

    void
    add_binding(byte[] oid,
                org.omg.CORBA.Object obj)
        throws com.ooc.OB.BootManagerPackage.AlreadyExists;

    //
    // IDL:ooc.com/OB/BootManager/remove_binding:1.0
    //
    /**
     *
     * Remove a binding from the internal table.
     *
     * @param oid The object id to remove.
     *
     * @exception com.ooc.OB.BootManagerPackage.NotFound Thrown if no binding found.
     *
     **/

    void
    remove_binding(byte[] oid)
        throws com.ooc.OB.BootManagerPackage.NotFound;

    //
    // IDL:ooc.com/OB/BootManager/set_locator:1.0
    //
    /**
     *
     * Set the BootLocator. The BootLocator is called when a binding
     * for an object id does not exist in the internal table.
     *
     * @param locator The BootLocator reference.
     *
     * @see BootLocator
     *
     **/

    void
    set_locator(BootLocator locator);
}
