// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/CorbalocURLScheme:1.0
//
/**
 *
 * CorbalocURLScheme implements the <code>corbaloc</code> URL scheme,
 * and serves as a registry for CorbalocProtocol objects.
 *
 * @see CorbalocProtocol
 *
 **/

public interface CorbalocURLSchemeOperations extends URLSchemeOperations
{
    //
    // IDL:ooc.com/OB/CorbalocURLScheme/add_protocol:1.0
    //
    /**
     *
     * Register a new <code>corbaloc</code> protocol.
     *
     * @param protocol The new protocol.
     *
     * @exception com.ooc.OB.CorbalocURLSchemePackage.ProtocolAlreadyExists Another protocol already exists
     * with the same name.
     *
     **/

    void
    add_protocol(CorbalocProtocol protocol)
        throws com.ooc.OB.CorbalocURLSchemePackage.ProtocolAlreadyExists;

    //
    // IDL:ooc.com/OB/CorbalocURLScheme/find_protocol:1.0
    //
    /**
     *
     * Find a protocol with the given name.
     *
     * @param name The protocol name, in lower case.
     *
     * @return The CorbalocProtocol, or nil if no match was found.
     *
     **/

    CorbalocProtocol
    find_protocol(String name);
}
