// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/DispatchStrategy:1.0
//
/**
 *
 * This interface represents a dispatch strategy. To dispatch a
 * request the ORB will pass a DispatchRequest. The dispatch strategy
 * should call DispatchRequest::invoke() in the correct thread
 * context.
 *
 * @see DispatchRequest
 * @see DispatchStrategyFactory
 *
 **/

public interface DispatchStrategyOperations
{
    //
    // IDL:ooc.com/OB/DispatchStrategy/id:1.0
    //
    /**
     *
     * Determine the id of this DispatchStrategy.  The ids of the
     * built-in DispatchStrategy objects are <code>SAME_THREAD</code>,
     * <code>THREAD_PER_REQUEST</code> and <code>THREAD_POOL</code>.
     * Use DispatchStrategyFactory to create instances of these objects.
     *
     **/

    int
    id();

    //
    // IDL:ooc.com/OB/DispatchStrategy/info:1.0
    //
    /**
     *
     * Determine information specific to this DispatchStrategy.
     *
     **/

    org.omg.CORBA.Any
    info();

    //
    // IDL:ooc.com/OB/DispatchStrategy/dispatch:1.0
    //
    /**
     *
     * Called to cause a DispatchRequest to be run.
     *
     * @param r The request to execute.
     *
     **/

    void
    dispatch(DispatchRequest r);
}
