// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/LocationTransparencyPolicy:1.0
//
/**
 *
 * The location transparency policy. This policy is used to control
 * how strict the ORB is in enforcing location transparency. This is
 * useful for performance reasons.
 *
 **/

public interface LocationTransparencyPolicyOperations extends org.omg.CORBA.PolicyOperations
{
    //
    // IDL:ooc.com/OB/LocationTransparencyPolicy/value:1.0
    //
    /**
     *
     * <code>LOCATION_TRANSPARENCY_STRICT</code> ensures strict
     * location transparency is followed.
     * <code>LOCATION_TRANSPARENCY_RELAXED</code> relaxes the location
     * transparency guarantees for performance reasons.  Specifically
     * for collocated method invocations, the dispatch concurrency
     * model will be ignored, and policy overrides are not
     * removed. The default value is
     * <code>LOCATION_TRANSPARENCY_STRICT</code>.
     *
     **/

    short
    value();
}
