// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/Logger:1.0
//
/**
 *
 * The ORBacus message logger interface.
 *
 **/

public interface LoggerOperations
{
    //
    // IDL:ooc.com/OB/Logger/info:1.0
    //
    /**
     *
     * Log an informational message.
     *
     * @param msg The message.
     *
     **/

    void
    info(String msg);

    //
    // IDL:ooc.com/OB/Logger/error:1.0
    //
    /**
     *
     * Log an error message.
     *
     * @param msg The error message.
     *
     **/

    void
    error(String msg);

    //
    // IDL:ooc.com/OB/Logger/warning:1.0
    //
    /**
     *
     * Log a warning message.
     *
     * @param msg The warning message.
     *
     **/

    void
    warning(String msg);

    //
    // IDL:ooc.com/OB/Logger/trace:1.0
    //
    /**
     *
     * Log a trace message.
     *
     * @param category The trace category.
     *
     * @param msg The trace message.
     *
     **/

    void
    trace(String category,
          String msg);
}
