// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/ProtocolPolicy:1.0
//
/**
 *
 * The protocol policy. This policy specifies the order in which profiles
 * should be tried.
 *
 **/

public interface ProtocolPolicyOperations extends org.omg.CORBA.PolicyOperations
{
    //
    // IDL:ooc.com/OB/ProtocolPolicy/value:1.0
    //
    /**
     *
     * If a <code>ProtocolPolicy</code> is set, then the value specifies
     * the list of plugins that may be used. The profiles of an IOR will
     * be used in the order specified by this policy. If no profile in an
     * IOR matches any of the plugins specified by this policy, a
     * <code>CORBA::TRANSIENT</code> exception will be raised. By
     * default, the ORB chooses the protocol to be used.
     *
     **/

    String[]
    value();

    //
    // IDL:ooc.com/OB/ProtocolPolicy/contains:1.0
    //
    /**
     *
     * Determines if this policy includes the given plugin id.
     *
     **/

    boolean
    contains(String id);
}
