// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/RetryPolicy:1.0
//
/**
 *
 * The retry policy. This policy is used to specify retry behavior after
 * communication failures (i.e., <code>CORBA::TRANSIENT</code> and
 * <code>CORBA::COMM_FAILURE</code> exceptions).
 *
 **/

public interface RetryPolicyOperations extends org.omg.CORBA.PolicyOperations
{
    //
    // IDL:ooc.com/OB/RetryPolicy/retry_mode:1.0
    //
    /**
     *
     * For retry_mode <code>RETRY_NEVER</code> indicates that requests
     * should never be retried, and the exception is re-thrown to the
     * application. <code>RETRY_STRICT</code> will retry once if the
     * exception completion status is <code>COMPLETED_NO</code>, in
     * order to guarantee at-most-once semantics. <code>RETRY_ALWAYS</code>
     * will retry once, regardless of the exception completion
     * status. The default value is <code>RETRY_STRICT</code>.
     * 
     * retry_interval is the time in milliseconds between reties. The
     * default is 0.
     * 
     * retry_max is the maximum number of retries. The default is 1.
     * 
     * retry_remote determines whether or not to retry on exceptions
     * received over-the-wire. The default is false: only retry on
     * locally generated exceptions.
     *
     * <B>Note:</B> Many TCP/IP stacks do not provide a reliable
     * indication of communication failure when sending smaller
     * requests, therefore the failure may not be detected until the
     * ORB attempts to read the reply.  In this case, the ORB must
     * assume that the remote end has received the request, in order
     * to guarantee at-most-once semantics for the request. The
     * implication is that when using the default setting of
     * <code>RETRY_STRICT</code>, most communication failures will not
     * cause a retry. This behavior can be relaxed using
     * <code>RETRY_ALWAYS</code>.
     *
     **/

    short
    retry_mode();

    //
    // IDL:ooc.com/OB/RetryPolicy/retry_interval:1.0
    //
    /***/

    int
    retry_interval();

    //
    // IDL:ooc.com/OB/RetryPolicy/retry_max:1.0
    //
    /***/

    int
    retry_max();

    //
    // IDL:ooc.com/OB/RetryPolicy/retry_remote:1.0
    //
    /***/

    boolean
    retry_remote();
}
