// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/TimeoutPolicy:1.0
//
/**
 *
 * The timeout policy. This policy can be used to specify the
 * default timeout for connection establishment and requests.
 * If an object also has <code>ConnectionTimeoutPolicy</code> or
 * <code>RequestTimeoutPolicy</code> set, those values have precedence.
 *
 * @see ConnectionTimeoutPolicy
 * @see RequestTimeoutPolicy
 *
 **/

public interface TimeoutPolicyOperations extends org.omg.CORBA.PolicyOperations
{
    //
    // IDL:ooc.com/OB/TimeoutPolicy/value:1.0
    //
    /**
     *
     * If an object has a <code>TimeoutPolicy</code> set and a
     * connection cannot be established or no response to a request
     * is available after <code>value</code> milliseconds, a
     * <code>CORBA::NO_RESPONSE</code> exception is raised.
     * The default value is <code>-1</code>, which means no timeout.
     *
     **/

    int
    value();
}
