// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/URLRegistry:1.0
//
/**
 *
 * The URLRegistry holds all of the supported URL schemes.
 *
 * @see URLScheme
 *
 **/

public interface URLRegistryOperations
{
    //
    // IDL:ooc.com/OB/URLRegistry/add_scheme:1.0
    //
    /**
     *
     * Register a new URL scheme.
     *
     * @param scheme The new scheme.
     *
     * @exception com.ooc.OB.URLRegistryPackage.SchemeAlreadyExists Another scheme already exists with
     * the same name.
     *
     **/

    void
    add_scheme(URLScheme scheme)
        throws com.ooc.OB.URLRegistryPackage.SchemeAlreadyExists;

    //
    // IDL:ooc.com/OB/URLRegistry/find_scheme:1.0
    //
    /**
     *
     * Find a scheme with the given name.
     *
     * @param name The scheme name, in lower case.
     *
     * @return The URLScheme, or nil if no match was found.
     *
     **/

    URLScheme
    find_scheme(String name);

    //
    // IDL:ooc.com/OB/URLRegistry/parse_url:1.0
    //
    /**
     *
     * Convert a URL into an object reference by delegating to a
     * registered URLScheme object.
     *
     * @param url The complete URL, including the scheme.
     *
     * @return An object reference.
     *
     * @exception BAD_PARAM In case the URL is invalid.
     *
     **/

    org.omg.CORBA.Object
    parse_url(String url);

    //
    // IDL:ooc.com/OB/URLRegistry/destroy:1.0
    //
    /**
     *
     * Invoke <code>destroy()</code> on all registered schemes, and
     * release any resources held by the object.
     *
     **/

    void
    destroy();
}
