// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/URLScheme:1.0
//
/**
 *
 * A URLScheme (e.g., <code>file:</code>, <code>corbaloc:</code>, etc.)
 * is responsible for converting a URL into an object reference.
 * All schemes must be installed in the <code>URLRegistry</code>.
 *
 * @see URLRegistry
 *
 **/

public interface URLSchemeOperations
{
    //
    // IDL:ooc.com/OB/URLScheme/name:1.0
    //
    /**
     *
     * Each scheme must have a unique name. All scheme names must
     * be in lower case, and do not include the trailing colon.
     *
     **/

    String
    name();

    //
    // IDL:ooc.com/OB/URLScheme/parse_url:1.0
    //
    /**
     *
     * Convert a URL into an object reference.
     *
     * @param url The complete URL, including the scheme.
     *
     * @return An object reference.
     *
     * @exception BAD_PARAM In case the URL is invalid.
     *
     **/

    org.omg.CORBA.Object
    parse_url(String url);

    //
    // IDL:ooc.com/OB/URLScheme/destroy:1.0
    //
    /**
     *
     * Release any resources held by the object.
     *
     **/

    void
    destroy();
}
