// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/UnknownExceptionInfo:1.0
//
/**
 *
 * Information about the context in which the unknown exception occurred.
 *
 **/

public interface UnknownExceptionInfoOperations
{
    //
    // IDL:ooc.com/OB/UnknownExceptionInfo/operation:1.0
    //
    /**
     *
     * The name of the operation that the servant was executing.
     *
     * @return The operation name.
     *
     **/

    String
    operation();

    //
    // IDL:ooc.com/OB/UnknownExceptionInfo/response_expected:1.0
    //
    /**
     *
     * Indicates whether the client is expecting a response to
     * this invocation.
     *
     * @return TRUE if the client expects a response, FALSE otherwise.
     *
     **/

    boolean
    response_expected();

    //
    // IDL:ooc.com/OB/UnknownExceptionInfo/transport_info:1.0
    //
    /**
     *
     * Obtains information about the transport on which this request
     * was received.
     *
     * @return The transport information, or NULL if the request
     * was made on a collocated servant.
     *
     **/

    com.ooc.OCI.TransportInfo
    transport_info();

    //
    // IDL:ooc.com/OB/UnknownExceptionInfo/describe_exception:1.0
    //
    /**
     *
     * Obtains a description of the exception. For example, in
     * Java this returns the exception stack trace. Calling
     * this operation in C++ will raise CORBA::NO_IMPLEMENT.
     *
     * @return The exception description.
     *
     **/

    String
    describe_exception();

    //
    // IDL:ooc.com/OB/UnknownExceptionInfo/raise_exception:1.0
    //
    /**
     *
     * Raises the unknown exception.
     *
     **/

    void
    raise_exception();
}
