// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// IDL:ooc.com/OB/WLogger:1.0
//
/**
 *
 * The ORBacus message logger interface with wide string support.
 *
 **/

public interface WLoggerOperations extends LoggerOperations
{
    //
    // IDL:ooc.com/OB/WLogger/winfo:1.0
    //
    /**
     *
     * Log a wide string informational message.
     *
     * @param msg The message.
     *
     **/

    void
    winfo(String msg);

    //
    // IDL:ooc.com/OB/WLogger/werror:1.0
    //
    /**
     *
     * Log an wide string error message.
     *
     * @param msg The error message.
     *
     **/

    void
    werror(String msg);

    //
    // IDL:ooc.com/OB/WLogger/wwarning:1.0
    //
    /**
     *
     * Log a wide string warning message.
     *
     * @param msg The warning message.
     *
     **/

    void
    wwarning(String msg);

    //
    // IDL:ooc.com/OB/WLogger/wtrace:1.0
    //
    /**
     *
     * Log a wide string trace message.
     *
     * @param category The trace category.
     *
     * @param msg The trace message.
     *
     **/

    void
    wtrace(String category,
           String msg);
}
