// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OBPortableServer;

//
// IDL:ooc.com/OBPortableServer/POAManagerFactory:1.0
//
/**
 *
 * This interface is a proprietary extension of the standard
 * POAManagerFactory.
 *
 * @see PortableServer::POAManagerFactory
 *
 **/

public interface POAManagerFactoryOperations extends org.omg.PortableServer.POAManagerFactoryOperations
{
    //
    // IDL:ooc.com/OBPortableServer/POAManagerFactory/destroy:1.0
    //
    /**
     *
     * Destroy all POAManagers.
     *
     **/

    void
    destroy();

    //
    // IDL:ooc.com/OBPortableServer/POAManagerFactory/create_endpoint_configuration_policy:1.0
    //
    /**
     *
     * These policy factory methods creates POAManager policies only.
     *
     **/

    EndpointConfigurationPolicy
    create_endpoint_configuration_policy(String value)
        throws org.omg.CORBA.PolicyError;

    //
    // IDL:ooc.com/OBPortableServer/POAManagerFactory/create_communications_concurrency_policy:1.0
    //
    /***/

    CommunicationsConcurrencyPolicy
    create_communications_concurrency_policy(short value)
        throws org.omg.CORBA.PolicyError;

    //
    // IDL:ooc.com/OBPortableServer/POAManagerFactory/create_giop_version_policy:1.0
    //
    /***/

    GIOPVersionPolicy
    create_giop_version_policy(short value)
        throws org.omg.CORBA.PolicyError;
}
