// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OBPortableServer;

//
// IDL:ooc.com/OBPortableServer/POA:1.0
//
/**
 *
 * This interface is a proprietary extension to the standard POA.
 *
 * @see PortableServer::POAManager
 *
 **/

public interface POAOperations extends org.omg.PortableServer.POAOperations
{
    //
    // IDL:ooc.com/OBPortableServer/POA/the_policies:1.0
    //
    /**
     *
     * Determine the policies that this POA was created with
     *
     **/

    org.omg.CORBA.Policy[]
    the_policies();

    //
    // IDL:ooc.com/OBPortableServer/POA/the_dispatch_strategy:1.0
    //
    /**
     *
     * Determine the DispatchStrategy in use by this POA
     *
     **/

    com.ooc.OB.DispatchStrategy
    the_dispatch_strategy();

    //
    // IDL:ooc.com/OBPortableServer/POA/adapter_template:1.0
    //
    /**
     *
     * Retrieve the Primary Object Reference Template
     *
     **/

    org.omg.PortableInterceptor.ObjectReferenceTemplate
    adapter_template();

    //
    // IDL:ooc.com/OBPortableServer/POA/current_factory:1.0
    //
    /**
     *
     * Retrieve the Secondary Object Reference Template
     *
     **/

    org.omg.PortableInterceptor.ObjectReferenceFactory
    current_factory();

    //
    // IDL:ooc.com/OBPortableServer/POA/the_ORB:1.0
    //
    /**
     *
     * Retrieve the ORB on which the POA was created
     *
     **/

    org.omg.CORBA.ORB
    the_ORB();

    //
    // IDL:ooc.com/OBPortableServer/POA/create_synchronization_policy:1.0
    //
    /**
     *
     * Create a synchronization policy
     *
     * @param value The SynchronizationPolicyValue
     *
     * @return A new SynchronizationPolicy
     *
     **/

    SynchronizationPolicy
    create_synchronization_policy(SynchronizationPolicyValue value);

    //
    // IDL:ooc.com/OBPortableServer/POA/create_dispatch_strategy_policy:1.0
    //
    /**
     *
     * Create a dispatch strategy policy
     *
     * @param value The DispatchStrategyPolicy
     *
     * @return A new DisptachStrategy
     *
     **/

    DispatchStrategyPolicy
    create_dispatch_strategy_policy(com.ooc.OB.DispatchStrategy value);
}
