// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

//
// IDL:ooc.com/OCI/AccFactory:1.0
//
/**
 *
 * An interface for an AccFactory object, which is used by CORBA
 * servers to create Acceptors.
 *
 * @see Acceptor
 * @see AccFactoryRegistry
 *
 **/

public interface AccFactoryOperations
{
    //
    // IDL:ooc.com/OCI/AccFactory/id:1.0
    //
    /** The plugin id. */

    String
    id();

    //
    // IDL:ooc.com/OCI/AccFactory/tag:1.0
    //
    /** The profile id tag. */

    int
    tag();

    //
    // IDL:ooc.com/OCI/AccFactory/create_acceptor:1.0
    //
    /**
     *
     * Create an Acceptor using the given configuration parameters.
     * Refer to the plug-in documentation for a description of the
     * configuration parameters supported for a particular protocol.
     *
     * @param params The configuration parameters.
     *
     * @return The new Acceptor.
     *
     * @exception com.ooc.OCI.InvalidParam If any of the parameters are invalid.
     *
     **/

    Acceptor
    create_acceptor(String[] params)
        throws InvalidParam;

    //
    // IDL:ooc.com/OCI/AccFactory/change_key:1.0
    //
    /**
     *
     * Change the object-key in the IOR profile for this given
     * protocol.
     *
     * @param ior The IOR
     *
     * @param key The new object key
     *
     **/

    void
    change_key(org.omg.IOP.IORHolder ior,
               byte[] key);

    //
    // IDL:ooc.com/OCI/AccFactory/get_info:1.0
    //
    /**
     *
     * Returns the information object associated with the Acceptor
     * factory.
     *
     * @return The Acceptor
     *
     **/

    AccFactoryInfo
    get_info();
}
