// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

//
// IDL:ooc.com/OCI/AccFactoryRegistry:1.0
//
/**
 *
 * A registry for Acceptor factories.
 *
 * @see Acceptor
 * @see AccFactory
 *
 **/

public interface AccFactoryRegistryOperations
{
    //
    // IDL:ooc.com/OCI/AccFactoryRegistry/add_factory:1.0
    //
    /**
     *
     * Adds an Acceptor factory to the registry.
     *
     * @param factory The Acceptor factory to add.
     *
     * @exception com.ooc.OCI.FactoryAlreadyExists If a factory already exists with the
     * same plugin id as the given factory.
     *
     **/

    void
    add_factory(AccFactory factory)
        throws FactoryAlreadyExists;

    //
    // IDL:ooc.com/OCI/AccFactoryRegistry/get_factory:1.0
    //
    /**
     *
     * Returns the factory with the given plugin id.
     *
     * @param id The plugin id.
     *
     * @return The Acceptor factory.
     *
     * @exception com.ooc.OCI.NoSuchFactory If no factory was found with a matching
     * plugin id.
     *
     **/

    AccFactory
    get_factory(String id)
        throws NoSuchFactory;

    //
    // IDL:ooc.com/OCI/AccFactoryRegistry/get_factories:1.0
    //
    /**
     *
     * Returns all registered factories.
     *
     * @return The Acceptor factories.
     *
     **/

    AccFactory[]
    get_factories();
}
