// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

//
// IDL:ooc.com/OCI/AcceptorInfo:1.0
//
/**
 *
 * Information on an OCI Acceptor object. Objects of this type must be
 * narrowed to an Acceptor information object for a concrete protocol
 * implementation, for example to <code>OCI::IIOP::AcceptorInfo</code>
 * in case the plug-in implements IIOP.
 *
 * @see Acceptor
 *
 **/

public interface AcceptorInfoOperations
{
    //
    // IDL:ooc.com/OCI/AcceptorInfo/id:1.0
    //
    /** The plugin id. */

    String
    id();

    //
    // IDL:ooc.com/OCI/AcceptorInfo/tag:1.0
    //
    /** The profile id tag. */

    int
    tag();

    //
    // IDL:ooc.com/OCI/AcceptorInfo/describe:1.0
    //
    /**
     *
     * Returns a human readable description of the transport.
     *
     * @return The description.
     *
     **/

    String
    describe();

    //
    // IDL:ooc.com/OCI/AcceptorInfo/add_accept_cb:1.0
    //
    /**
     *
     * Add a callback that is called whenever a new connection is
     * accepted. If the callback has already been registered, this
     * method has no effect.
     *
     * @param cb The callback to add.
     *
     **/

    void
    add_accept_cb(AcceptCB cb);

    //
    // IDL:ooc.com/OCI/AcceptorInfo/remove_accept_cb:1.0
    //
    /**
     *
     * Remove an accept callback. If the callback was not registered,
     * this method has no effect.
     *
     * @param cb The callback to remove.
     *
     **/

    void
    remove_accept_cb(AcceptCB cb);
}
