// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

//
// IDL:ooc.com/OCI/ConFactoryRegistry:1.0
//
/**
 *
 * A registry for Connector factories.
 *
 * @see Connector
 * @see ConFactory
 *
 **/

public interface ConFactoryRegistryOperations
{
    //
    // IDL:ooc.com/OCI/ConFactoryRegistry/add_factory:1.0
    //
    /**
     *
     * Adds a Connector factory to the registry.
     *
     * @param factory The Connector factory to add.
     *
     * @exception com.ooc.OCI.FactoryAlreadyExists If a factory already exists with the
     * same plugin id as the given factory.
     *
     **/

    void
    add_factory(ConFactory factory)
        throws FactoryAlreadyExists;

    //
    // IDL:ooc.com/OCI/ConFactoryRegistry/get_factory:1.0
    //
    /**
     *
     * Returns the factory with the given plugin id.
     *
     * @param id The plugin id.
     *
     * @return The Connector factory.
     *
     * @exception com.ooc.OCI.NoSuchFactory If no factory was found with a matching
     * plugin id.
     *
     **/

    ConFactory
    get_factory(String id)
        throws NoSuchFactory;

    //
    // IDL:ooc.com/OCI/ConFactoryRegistry/get_factories:1.0
    //
    /**
     *
     * Returns all registered factories.
     *
     * @return The Connector factories.
     *
     **/

    ConFactory[]
    get_factories();
}
