// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

//
// IDL:ooc.com/OCI/ConnectorInfo:1.0
//
/**
 *
 * Information on a OCI Connector object. Objects of this type must be
 * narrowed to a Connector information object for a concrete protocol
 * implementation, for example to <code>OCI::IIOP::ConnectorInfo</code>
 * in case the plug-in implements IIOP.
 *
 * @see Connector
 *
 **/

public interface ConnectorInfoOperations
{
    //
    // IDL:ooc.com/OCI/ConnectorInfo/id:1.0
    //
    /** The plugin id. */

    String
    id();

    //
    // IDL:ooc.com/OCI/ConnectorInfo/tag:1.0
    //
    /** The profile id tag. */

    int
    tag();

    //
    // IDL:ooc.com/OCI/ConnectorInfo/describe:1.0
    //
    /**
     *
     * Returns a human readable description of the transport.
     *
     * @return The description.
     *
     **/

    String
    describe();

    //
    // IDL:ooc.com/OCI/ConnectorInfo/add_connect_cb:1.0
    //
    /**
     *
     * Add a callback that is called whenever a new connection is
     * established. If the callback has already been registered, this
     * method has no effect.
     *
     * @param cb The callback to add.
     *
     **/

    void
    add_connect_cb(ConnectCB cb);

    //
    // IDL:ooc.com/OCI/ConnectorInfo/remove_connect_cb:1.0
    //
    /**
     *
     * Remove a connect callback. If the callback was not registered,
     * this method has no effect.
     *
     * @param cb The callback to remove.
     *
     **/

    void
    remove_connect_cb(ConnectCB cb);
}
