// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

//
// IDL:ooc.com/OCI/Current:1.0
//
/**
 *
 * Interface to access Transport and Acceptor information objects
 * related to the current request.
 *
 **/

public interface CurrentOperations extends org.omg.CORBA.CurrentOperations
{
    //
    // IDL:ooc.com/OCI/Current/get_oci_transport_info:1.0
    //
    /**
     *
     * This method returns the Transport information object for the
     * Transport used to invoke the current request.
     *
     * @returns The Transport information object.
     *
     **/

    TransportInfo
    get_oci_transport_info();

    //
    // IDL:ooc.com/OCI/Current/get_oci_acceptor_info:1.0
    //
    /**
     *
     * This method returns the Acceptor information object for the
     * Acceptor which created the Transport used to invoke the current
     * request.
     *
     * @returns The Acceptor information object.
     *
     **/

    AcceptorInfo
    get_oci_acceptor_info();
}
