// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

//
// IDL:ooc.com/OCI/Plugin:1.0
//
/**
 *
 * The interface for a Plugin object, which is used to initialize
 * an OCI plug-in.
 *
 **/

public interface PluginOperations
{
    //
    // IDL:ooc.com/OCI/Plugin/id:1.0
    //
    /** The plugin id. */

    String
    id();

    //
    // IDL:ooc.com/OCI/Plugin/tag:1.0
    //
    /** The profile id tag. */

    int
    tag();

    //
    // IDL:ooc.com/OCI/Plugin/init_client:1.0
    //
    /**
     *
     * Initialize the client-side of the plug-in.
     *
     * @param params Plug-in specific parameters.
     *
     **/

    void
    init_client(String[] params);

    //
    // IDL:ooc.com/OCI/Plugin/init_server:1.0
    //
    /**
     *
     * Initialize the server-side of the plug-in.
     *
     * @param params Plug-in specific parameters.
     *
     **/

    void
    init_server(String[] params);
}
