// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

//
// IDL:ooc.com/OCI/ProfileInfo:1.0
//
/**
 *
 * Basic information about an IOR profile. Profiles for specific
 * protocols contain additional data. (For example, an IIOP profile
 * also contains a hostname and a port number.)
 *
 * @member key The object key.
 *
 * @member major The major version number of the ORB's protocol. (For
 * example, the major GIOP version, if the underlying ORB uses GIOP.)
 *
 * @member minor The minor version number of the ORB's protocol. (For
 * example, the minor GIOP version, if the underlying ORB uses GIOP.)
 *
 * @member id The id of the profile that contains this information.
 *
 * @member index The position index of this profile in an IOR.
 *
 * @member components A sequence of tagged components.
 *
 **/

final public class ProfileInfo implements org.omg.CORBA.portable.IDLEntity
{
    private static final String _ob_id = "IDL:ooc.com/OCI/ProfileInfo:1.0";

    public
    ProfileInfo()
    {
    }

    public
    ProfileInfo(byte[] key,
                byte major,
                byte minor,
                int id,
                int index,
                org.omg.IOP.TaggedComponent[] components)
    {
        this.key = key;
        this.major = major;
        this.minor = minor;
        this.id = id;
        this.index = index;
        this.components = components;
    }

    public byte[] key;
    public byte major;
    public byte minor;
    public int id;
    public int index;
    public org.omg.IOP.TaggedComponent[] components;
}
