// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package org.omg.CONV_FRAME;

//
// IDL:omg.org/CONV_FRAME/CodeSetComponent:1.0
//
final public class CodeSetComponentHelper
{
    public static void
    insert(org.omg.CORBA.Any any, CodeSetComponent val)
    {
        org.omg.CORBA.portable.OutputStream out = any.create_output_stream();
        write(out, val);
        any.read_value(out.create_input_stream(), type());
    }

    public static CodeSetComponent
    extract(org.omg.CORBA.Any any)
    {
        if(any.type().equivalent(type()))
            return read(any.create_input_stream());
        else
            throw new org.omg.CORBA.BAD_OPERATION();
    }

    private static org.omg.CORBA.TypeCode typeCode_;

    public static org.omg.CORBA.TypeCode
    type()
    {
        if(typeCode_ == null)
        {
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
            org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[2];

            members[0] = new org.omg.CORBA.StructMember();
            members[0].name = "native_code_set";
            members[0].type = CodeSetIdHelper.type();

            members[1] = new org.omg.CORBA.StructMember();
            members[1].name = "conversion_code_sets";
            members[1].type = orb.create_sequence_tc(0, CodeSetIdHelper.type());

            typeCode_ = orb.create_struct_tc(id(), "CodeSetComponent", members);
        }

        return typeCode_;
    }

    public static String
    id()
    {
        return "IDL:omg.org/CONV_FRAME/CodeSetComponent:1.0";
    }

    public static CodeSetComponent
    read(org.omg.CORBA.portable.InputStream in)
    {
        CodeSetComponent _ob_v = new CodeSetComponent();
        _ob_v.native_code_set = CodeSetIdHelper.read(in);
        int len0 = in.read_ulong();
        _ob_v.conversion_code_sets = new int[len0];
        in.read_ulong_array(_ob_v.conversion_code_sets, 0, len0);
        return _ob_v;
    }

    public static void
    write(org.omg.CORBA.portable.OutputStream out, CodeSetComponent val)
    {
        CodeSetIdHelper.write(out, val.native_code_set);
        int len0 = val.conversion_code_sets.length;
        out.write_ulong(len0);
        out.write_ulong_array(val.conversion_code_sets, 0, len0);
    }
}
