// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package org.omg.CORBA;

//
// IDL:omg.org/CORBA/Container:1.0
//
/***/

public interface ContainerOperations extends IRObjectOperations
{
    //
    // IDL:omg.org/CORBA/Container/lookup:1.0
    //
    /***/

    Contained
    lookup(String search_name);

    //
    // IDL:omg.org/CORBA/Container/contents:1.0
    //
    /***/

    Contained[]
    contents(DefinitionKind limit_type,
             boolean exclude_inherited);

    //
    // IDL:omg.org/CORBA/Container/lookup_name:1.0
    //
    /***/

    Contained[]
    lookup_name(String search_name,
                int levels_to_search,
                DefinitionKind limit_type,
                boolean exclude_inherited);

    //
    // IDL:omg.org/CORBA/Container/describe_contents:1.0
    //
    /***/

    org.omg.CORBA.ContainerPackage.Description[]
    describe_contents(DefinitionKind limit_type,
                      boolean exclude_inherited,
                      int max_returned_objs);

    //
    // IDL:omg.org/CORBA/Container/create_module:1.0
    //
    /***/

    ModuleDef
    create_module(String id,
                  String name,
                  String version);

    //
    // IDL:omg.org/CORBA/Container/create_constant:1.0
    //
    /***/

    ConstantDef
    create_constant(String id,
                    String name,
                    String version,
                    IDLType type,
                    org.omg.CORBA.Any value);

    //
    // IDL:omg.org/CORBA/Container/create_struct:1.0
    //
    /***/

    StructDef
    create_struct(String id,
                  String name,
                  String version,
                  StructMember[] members);

    //
    // IDL:omg.org/CORBA/Container/create_union:1.0
    //
    /***/

    UnionDef
    create_union(String id,
                 String name,
                 String version,
                 IDLType discriminator_type,
                 UnionMember[] members);

    //
    // IDL:omg.org/CORBA/Container/create_enum:1.0
    //
    /***/

    EnumDef
    create_enum(String id,
                String name,
                String version,
                String[] members);

    //
    // IDL:omg.org/CORBA/Container/create_alias:1.0
    //
    /***/

    AliasDef
    create_alias(String id,
                 String name,
                 String version,
                 IDLType original_type);

    //
    // IDL:omg.org/CORBA/Container/create_interface:1.0
    //
    /***/

    InterfaceDef
    create_interface(String id,
                     String name,
                     String version,
                     InterfaceDef[] base_interfaces);

    //
    // IDL:omg.org/CORBA/Container/create_abstract_interface:1.0
    //
    /***/

    AbstractInterfaceDef
    create_abstract_interface(String id,
                              String name,
                              String version,
                              AbstractInterfaceDef[] base_interfaces);

    //
    // IDL:omg.org/CORBA/Container/create_local_interface:1.0
    //
    /***/

    LocalInterfaceDef
    create_local_interface(String id,
                           String name,
                           String version,
                           InterfaceDef[] base_interfaces);

    //
    // IDL:omg.org/CORBA/Container/create_exception:1.0
    //
    /***/

    ExceptionDef
    create_exception(String id,
                     String name,
                     String version,
                     StructMember[] members);

    //
    // IDL:omg.org/CORBA/Container/create_value:1.0
    //
    /***/

    ValueDef
    create_value(String id,
                 String name,
                 String version,
                 boolean is_custom,
                 boolean is_abstract,
                 ValueDef base_value,
                 boolean is_truncatable,
                 ValueDef[] abstract_base_values,
                 InterfaceDef[] supported_interfaces,
                 Initializer[] initializers);

    //
    // IDL:omg.org/CORBA/Container/create_value_box:1.0
    //
    /***/

    ValueBoxDef
    create_value_box(String id,
                     String name,
                     String version,
                     IDLType original_type_def);

    //
    // IDL:omg.org/CORBA/Container/create_native:1.0
    //
    /***/

    NativeDef
    create_native(String id,
                  String name,
                  String version);
}
