// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package org.omg.GIOP;

//
// IDL:omg.org/GIOP/RequestHeader_1_1:1.0
//
final public class RequestHeader_1_1Helper
{
    public static void
    insert(org.omg.CORBA.Any any, RequestHeader_1_1 val)
    {
        org.omg.CORBA.portable.OutputStream out = any.create_output_stream();
        write(out, val);
        any.read_value(out.create_input_stream(), type());
    }

    public static RequestHeader_1_1
    extract(org.omg.CORBA.Any any)
    {
        if(any.type().equivalent(type()))
            return read(any.create_input_stream());
        else
            throw new org.omg.CORBA.BAD_OPERATION();
    }

    private static org.omg.CORBA.TypeCode typeCode_;

    public static org.omg.CORBA.TypeCode
    type()
    {
        if(typeCode_ == null)
        {
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
            org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[7];

            members[0] = new org.omg.CORBA.StructMember();
            members[0].name = "service_context";
            members[0].type = org.omg.IOP.ServiceContextListHelper.type();

            members[1] = new org.omg.CORBA.StructMember();
            members[1].name = "request_id";
            members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);

            members[2] = new org.omg.CORBA.StructMember();
            members[2].name = "response_expected";
            members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);

            members[3] = new org.omg.CORBA.StructMember();
            members[3].name = "reserved";
            members[3].type = orb.create_array_tc(3, orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_octet));

            members[4] = new org.omg.CORBA.StructMember();
            members[4].name = "object_key";
            members[4].type = orb.create_sequence_tc(0, orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_octet));

            members[5] = new org.omg.CORBA.StructMember();
            members[5].name = "operation";
            members[5].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);

            members[6] = new org.omg.CORBA.StructMember();
            members[6].name = "requesting_principal";
            members[6].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_Principal);

            typeCode_ = orb.create_struct_tc(id(), "RequestHeader_1_1", members);
        }

        return typeCode_;
    }

    public static String
    id()
    {
        return "IDL:omg.org/GIOP/RequestHeader_1_1:1.0";
    }

    public static RequestHeader_1_1
    read(org.omg.CORBA.portable.InputStream in)
    {
        RequestHeader_1_1 _ob_v = new RequestHeader_1_1();
        _ob_v.service_context = org.omg.IOP.ServiceContextListHelper.read(in);
        _ob_v.request_id = in.read_ulong();
        _ob_v.response_expected = in.read_boolean();
        int len0 = 3;
        _ob_v.reserved = new byte[len0];
        in.read_octet_array(_ob_v.reserved, 0, len0);
        int len1 = in.read_ulong();
        _ob_v.object_key = new byte[len1];
        in.read_octet_array(_ob_v.object_key, 0, len1);
        _ob_v.operation = in.read_string();
        _ob_v.requesting_principal = in.read_Principal();
        return _ob_v;
    }

    public static void
    write(org.omg.CORBA.portable.OutputStream out, RequestHeader_1_1 val)
    {
        org.omg.IOP.ServiceContextListHelper.write(out, val.service_context);
        out.write_ulong(val.request_id);
        out.write_boolean(val.response_expected);
        int len0 = val.reserved.length;
        if(len0 != 3)
             throw new org.omg.CORBA.MARSHAL();
        out.write_octet_array(val.reserved, 0, len0);
        int len1 = val.object_key.length;
        out.write_ulong(len1);
        out.write_octet_array(val.object_key, 0, len1);
        out.write_string(val.operation);
        out.write_Principal(val.requesting_principal);
    }
}
