// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package org.omg.PortableServer;

//
// IDL:omg.org/PortableServer/POAManagerFactory:1.0
//
/**
 *
 * A Factory for PortableServer::POAManager.
 *
 * @see PortableServer::POAManager
 *
 **/

public interface POAManagerFactoryOperations
{
    //
    // IDL:omg.org/PortableServer/POAManagerFactory/create_POAManager:1.0
    //
    /**
     *
     * Create a new POAManager. The configuration properties for this
     * POA manager will be held in "ooc.orb.poamanager.<name>." If the
     * name is the empty string then a POA manager with a unique name
     * will be created. The POAManager will be created with a single
     * IIOP Acceptor.
     *
     * @param id The POAManager id.
     *
     * @param policies The policy list for the POAManager.
     *
     * @return A POAManager.
     *
     * @exception org.omg.PortableServer.POAManagerFactoryPackage.ManagerAlreadyExists If a POAManager with the same
     * name already exists.
     *
     * @exception PolicyError If the supplied policy list contains
     * a conflict.
     *
     **/

    POAManager
    create_POAManager(String id,
                      org.omg.CORBA.Policy[] policies)
        throws org.omg.PortableServer.POAManagerFactoryPackage.ManagerAlreadyExists,
               org.omg.CORBA.PolicyError;

    //
    // IDL:omg.org/PortableServer/POAManagerFactory/list:1.0
    //
    /**
     *
     * List all POA Managers.
     *
     * @return A sequence of POAManagers.
     *
     **/

    POAManager[]
    list();

    //
    // IDL:omg.org/PortableServer/POAManagerFactory/find:1.0
    //
    /**
     *
     * Find a specific POA Manager.
     *
     * @param id The POAManager id.
     *
     * @return The POAManager given by id, or null if not found.
     *
     **/

    POAManager
    find(String id);
}
