// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************
package org.omg.CORBA;

final public class INTERNALHelper
{
    public static void
    insert(Any any, INTERNAL val)
    {
        org.omg.CORBA.portable.OutputStream out = any.create_output_stream();
        write(out, val);
        any.read_value(out.create_input_stream(), type());
    }

    public static INTERNAL
    extract(Any any)
    {
	if(any.type().equivalent(type()))
	    return read(any.create_input_stream());
	else
	    throw new BAD_OPERATION();
    }

    private static TypeCode typeCode_;

    public static TypeCode
    type()
    {
        if(typeCode_ == null)
        {
            ORB orb = ORB.init();
            StructMember[] members = new StructMember[2];
            members[0] = new StructMember();
            members[0].name = "minor";
            members[0].type = orb.get_primitive_tc(TCKind.tk_ulong);
            members[1] = new StructMember();
            members[1].name = "completed";
            members[1].type = CompletionStatusHelper.type();

            typeCode_ = orb.create_exception_tc(id(), "INTERNAL", members);
        }

        return typeCode_;
    }

    public static String
    id()
    {
        return "IDL:omg.org/CORBA/INTERNAL:1.0";
    }

    public static INTERNAL
    read(org.omg.CORBA.portable.InputStream in)
    {
        if(!id().equals(in.read_string()))
            throw new MARSHAL();

        INTERNAL val = new INTERNAL();
	val.minor = in.read_ulong();
	val.completed = CompletionStatus.from_int(in.read_ulong());
        return val;
    }

    public static void
    write(org.omg.CORBA.portable.OutputStream out, INTERNAL val)
    {
        out.write_string(id());
	out.write_ulong(val.minor);
	out.write_ulong(val.completed.value());
    }
}
