// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************
package org.omg.CORBA;

abstract public class SystemException extends java.lang.RuntimeException
{
    public int minor;
    public CompletionStatus completed;

    protected
    SystemException(String reason, int minor, CompletionStatus status)
    {
	super(reason);
	this.minor = minor;
	this.completed = status;
    }

    public String
    toString()
    {
        String s = super.toString() + "  minor code: 0x" +
                   Integer.toHexString(minor);

        switch(completed.value())
        {
        case CompletionStatus._COMPLETED_YES:
            s += "  completed: Yes";
            break;

        case CompletionStatus._COMPLETED_NO:
            s += "  completed: No";
            break;

        case CompletionStatus._COMPLETED_MAYBE:
        default:
            s += "  completed: Maybe";
            break;
        }

        return s;
    }
}
