// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package test.codesets;

import org.omg.CORBA.*;

final public class Client
{
    public static int
    run(ORB orb, String[] args)
	throws org.omg.CORBA.UserException
    {
	org.omg.CORBA.Object obj =
	    orb.string_to_object("relfile:TestCodeSets.ref");
	if(obj == null)
	{
	    System.out.println("Can't read IOR from TestCodeSets.ref");
	    return 0;	    
	}
	
	TestCodeSets p = TestCodeSetsHelper.narrow(obj);
	com.ooc.OB.Assert._OB_assert(p != null);
	
	{
	    char wc, wcRet;
	    
	    wc = 'a';
	    wcRet = p.testWChar(wc);
	    com.ooc.OB.Assert._OB_assert(wc == wcRet);

	    wc = (char)0x1234;
	    wcRet = p.testWChar(wc);
	    com.ooc.OB.Assert._OB_assert(wc == wcRet);
	}
	
	{
	    String ws, wsRet;
	    
	    ws = "Hello, World!";
	    wsRet = p.testWString(ws);
	    com.ooc.OB.Assert._OB_assert(ws.equals(wsRet));
	}

	p.deactivate();

	return 0;
    }
    
    public static void
    main(String[] args)
    {
	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");
	
        int status = 0;
        ORB orb = null;
	
        try
        {
            orb = ORB.init(args, props);
            status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
