// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package test.poa;

import org.omg.CORBA.*;

public class TestClient extends test.common.TestBase
{
    public static void
    main(String[] args)
    {
	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
		  "com.ooc.CORBA.ORBSingleton");

        ORB orb = null;

	try
	{
            //
            // Create ORB
            //
            orb = ORB.init(args, props);

	    //
	    // Get server
	    //
	    org.omg.CORBA.Object obj =
                orb.string_to_object("relfile:/Test.ref");
	    if(obj == null)
	    {
		System.err.println("Can't read from Test.ref");
		System.exit(1);
	    }

	    TestServer server = TestServerHelper.narrow(obj);
	    TEST(server != null);

	    TestInfo[] info = server.get_info();
	    for(int i = 0 ; i < info.length ; i++)
	    {
		try
		{
		    info[i].obj.aMethod();
		    TEST(info[i].except_id.length() == 0);
		}
		catch(SystemException ex)
		{
                    String id = com.ooc.OB.Util.getExceptionId(ex);
                    if(!id.equals(info[i].except_id))
                    {
                        System.err.println("TestClient: Invocation on " +
                                           "object #" + i + " raised an " +
                                           "unexpected exception");
                        System.err.println("Expected " + info[i].except_id +
                                           " but caught " + id);
                        TEST(false);
                    }
		}
	    }

	    server.deactivate();
	}	    
	catch(SystemException ex)
	{
	    ex.printStackTrace();
	    System.exit(1);
	}

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(SystemException ex)
            {
                ex.printStackTrace();
                System.exit(1);
            }
        }

        System.exit(0);
    }
}
