// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package test.poa;

import java.util.*;

final public class TestDispatchStrategyClient extends test.common.TestBase
{
    public static void
    main(String args[])
    {
        Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
	          "com.ooc.CORBA.ORBSingleton");

        org.omg.CORBA.ORB orb = null;

        try
	{
	    //
	    // Create ORB
	    //
	    orb = org.omg.CORBA.ORB.init(args, props);

	    //
	    // Get test server object reference
	    //
	    org.omg.CORBA.Object obj =
	        orb.string_to_object("relfile:/Test.ref");
	    if(obj == null)
	    {
	        System.err.println("TestDispatchStrategyClient: " +
				   "cannot read IOR from Test.ref");
		System.exit(1);
	    }
	
	    TestServer server = TestServerHelper.narrow(obj);
	    TestInfo[] info = server.get_info();

	    //
	    // Test the thread dispatch strategies by calling
	    // methods on each returned object reference
	    //
	    org.omg.CORBA.Request req;

	    int idx;
	    for(idx = 0 ; idx < info.length ; idx++)
	    {
	        TEST(info[idx].obj != null);

	        for(int idx2 = 0 ; idx2 < 4 ; idx2++)
	        {
	            req = info[idx].obj._request("aMethod");
	            req.send_deferred();
	        }
	    }

	    idx = info.length * 4;
	    do
	    {
	        req = orb.get_next_response();
	    } while(--idx != 0);

	    server.deactivate();
        }
        catch(org.omg.CORBA.SystemException ex)
        {
	    ex.printStackTrace();
	    System.exit(1);
        }
        catch(org.omg.CORBA.UserException ex)
        {
	    ex.printStackTrace();
	    System.exit(1);
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(org.omg.CORBA.SystemException ex)
            {
                ex.printStackTrace();
                System.exit(1);
            }
        }

        System.exit(0);
    }
}
