// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package test.poa;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;

final class TestPOAManagerClient extends test.common.TestBase
{
    public static void
    main(String[] args)
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        ORB orb = null;

        try
        {
            //
            // Create ORB
            //
            orb = ORB.init(args, props);
            
            org.omg.CORBA.Object obj =
                orb.string_to_object("relfile:/Test.ref");
            if(obj == null)
            {
                System.err.println("cannot read IOR from Test.ref");
                System.exit(1);
            }
            TestServer server = TestServerHelper.narrow(obj);

            obj = orb.string_to_object("relfile:/POAManagerProxy.ref");
            if(obj == null)
            {
                System.err.println("cannot read IOR from POAManagerProxy.ref");
                System.exit(1);
            }
            POAManagerProxy manager = POAManagerProxyHelper.narrow(obj);

            try
            {
                manager.activate();
            }
            catch(test.poa.POAManagerProxyPackage.AdapterInactive ex)
            {
                TEST(false);
            }

            TestInfo[] info = server.get_info();

            new TestPOAManagerCommon(manager, info);

            server.deactivate();
        }
        catch(SystemException ex)
        {
            ex.printStackTrace();
            System.exit(1);
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(SystemException ex)
            {
                ex.printStackTrace();
                System.exit(1);
            }
        }

        System.exit(0);
    }
}
