// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package test.types;

//
// IDL:OctetSeq:1.0
//
final public class OctetSeqHelper
{
    public static void
    insert(org.omg.CORBA.Any any, byte[] val)
    {
        org.omg.CORBA.portable.OutputStream out = any.create_output_stream();
        write(out, val);
        any.read_value(out.create_input_stream(), type());
    }

    public static byte[]
    extract(org.omg.CORBA.Any any)
    {
        if(any.type().equivalent(type()))
            return read(any.create_input_stream());
        else
            throw new org.omg.CORBA.BAD_OPERATION();
    }

    private static org.omg.CORBA.TypeCode typeCode_;

    public static org.omg.CORBA.TypeCode
    type()
    {
        if(typeCode_ == null)
        {
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
            typeCode_ = orb.create_alias_tc(id(), "OctetSeq", orb.create_sequence_tc(0, orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_octet)));
        }

        return typeCode_;
    }

    public static String
    id()
    {
        return "IDL:OctetSeq:1.0";
    }

    public static byte[]
    read(org.omg.CORBA.portable.InputStream in)
    {
        byte[] _ob_v;
        int len0 = in.read_ulong();
        _ob_v = new byte[len0];
        in.read_octet_array(_ob_v, 0, len0);
        return _ob_v;
    }

    public static void
    write(org.omg.CORBA.portable.OutputStream out, byte[] val)
    {
        int len0 = val.length;
        out.write_ulong(len0);
        out.write_octet_array(val, 0, len0);
    }
}
