// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.IOP;

final public class CodecFactory_impl extends org.omg.CORBA.LocalObject
    implements org.omg.IOP.CodecFactory
{
    private org.omg.IOP.Codec cdrCodec_; // Cached CDR Codec
    private com.ooc.OB.ORBInstance orbInstance_; // The ORBInstance

    // ----------------------------------------------------------------------
    // CodecFactory_impl public member implementation
    // ----------------------------------------------------------------------

    public org.omg.IOP.Codec
    create_codec(org.omg.IOP.Encoding encoding)
	throws org.omg.IOP.CodecFactoryPackage.UnknownEncoding
    {
	com.ooc.OB.Assert._OB_assert(orbInstance_ != null);

	// TODO: check major/minor version
	if(encoding.format != org.omg.IOP.ENCODING_CDR_ENCAPS.value)
	    throw new org.omg.IOP.CodecFactoryPackage.UnknownEncoding();

	//
	// Double checked locking
	//
	if(cdrCodec_ == null)
	{
	    synchronized(this)
	    {
		if(cdrCodec_ == null)
		    cdrCodec_ = new CDRCodec(orbInstance_);
	    }
	}

	return cdrCodec_;
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    public void
    _OB_setORBInstance(com.ooc.OB.ORBInstance orbInstance)
    {
	orbInstance_ = orbInstance;
    }
}

