// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

final public class BootManager_impl extends org.omg.CORBA.LocalObject
    implements BootManager
{
    //
    // Set of known bindings
    //
    private java.util.Hashtable bindings_;

    //
    // The Boot Locator. There is no need for the BootLocatorHolder
    // since assign and read methods are atomic in Java.
    //
    private BootLocator locator_ = null;

    public
    BootManager_impl()
    {
        bindings_ = new java.util.Hashtable(17);
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    add_binding(byte[] id, org.omg.CORBA.Object obj)
        throws com.ooc.OB.BootManagerPackage.AlreadyExists
    {
	ObjectIdHasher oid = new ObjectIdHasher(id);

        //
        // If binding id is not already mapped add the binding.
        //
	synchronized(bindings_)
	{
            if(bindings_.containsKey(oid))
                throw new com.ooc.OB.BootManagerPackage.AlreadyExists();

            bindings_.put(oid, obj);
	}
    }

    public void
    remove_binding(byte[] id)
        throws com.ooc.OB.BootManagerPackage.NotFound
    {
	ObjectIdHasher oid = new ObjectIdHasher(id);

        //
        // If binding id is mapped remove the binding
        //
	synchronized(bindings_)
	{
	    if(bindings_.remove(oid) == null)
	        throw new com.ooc.OB.BootManagerPackage.NotFound();
	}
    }

    public void
    set_locator(BootLocator locator)
    {
        //
        // Set the BootLocator
        //
        locator_ = locator;
    }

    //-------------------------------------------------------------------
    // BootManager_impl internal methods
    // ------------------------------------------------------------------

    public org.omg.IOP.IOR
    _OB_locate(byte[] id)
    {
        //
        // First check the internal hash table and then the 
        // registered BootLocator (if there is one) to find the
        // binding for the requested ObjectId.
        //
	ObjectIdHasher oid = new ObjectIdHasher(id);
	org.omg.CORBA.Object obj = (org.omg.CORBA.Object)bindings_.get(oid);
        if(obj == null && locator_ != null)
	{
            try
	    {
		org.omg.CORBA.ObjectHolder objHolder =
		    new org.omg.CORBA.ObjectHolder();
		org.omg.CORBA.BooleanHolder addHolder = 
		    new org.omg.CORBA.BooleanHolder();
	        locator_.locate(id, objHolder, addHolder);

		obj = objHolder.value;
	        if(addHolder.value)
	            bindings_.put(oid, obj);
	    }
	    catch(com.ooc.OB.BootManagerPackage.NotFound ex)
	    {
	    }
        }

	if(obj == null)
	    return null;

	com.ooc.CORBA.Delegate p = (com.ooc.CORBA.Delegate)
            (((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate());
        return p._OB_IOR();
    }
}
