// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

final public class CodeSetIORInterceptor_impl extends org.omg.CORBA.LocalObject
    implements org.omg.PortableInterceptor.IORInterceptor_3_0
{
    //
    // The native codesets
    //
    private int nativeCs_;
    private int nativeWcs_;

    public CodeSetIORInterceptor_impl(int nativeCs, int nativeWcs)
    {
	nativeCs_ = nativeCs;
	nativeWcs_ = nativeWcs;
    }

    //
    // IDL to Java Mapping
    //

    public String
    name()
    {
	return "";
    }

    public void
    destroy()
    {
    }

    public void
    establish_components(org.omg.PortableInterceptor.IORInfo info)
    {
	org.omg.CONV_FRAME.CodeSetComponent c =
	    CodeSetUtil.createCodeSetComponent(nativeCs_, false);
	org.omg.CONV_FRAME.CodeSetComponent wc =
	    CodeSetUtil.createCodeSetComponent(nativeWcs_, true);
        org.omg.CONV_FRAME.CodeSetComponentInfo codeSetInfo =
	    new org.omg.CONV_FRAME.CodeSetComponentInfo(c, wc);

        org.omg.IOP.TaggedComponent component =
            new org.omg.IOP.TaggedComponent();
        component.tag = org.omg.IOP.TAG_CODE_SETS.value;

        //
        // The Codec could be used here -- but that means that the
        // Any insertion/extraction operators would have to be
        // generated unnecessarily
        //
        com.ooc.OCI.Buffer buf = new com.ooc.OCI.Buffer();
        com.ooc.CORBA.OutputStream out =
            new com.ooc.CORBA.OutputStream(buf);
        out._OB_writeEndian();
        org.omg.CONV_FRAME.CodeSetComponentInfoHelper.write(out,
                                                            codeSetInfo);

        component.component_data = new byte[out._OB_pos()];
        System.arraycopy(buf.data(), 0, component.component_data, 0,
                         buf.length());

        try
        {
            info.add_ior_component(component);
        }
        catch(org.omg.CORBA.BAD_PARAM ex)
        {
            // Ignore - profile may not be supported
        }
    }

    public void
    components_established(org.omg.PortableInterceptor.IORInfo info)
    {
    }

    public void
    adapter_manager_state_changed(String id, short state)
    {
    }

    public void
    adapter_state_changed(
        org.omg.PortableInterceptor.ObjectReferenceTemplate[] templates,
	short state)
    {
    }
}
