// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

public class IORURLScheme_impl extends org.omg.CORBA.LocalObject
                               implements URLScheme
{
    private ORBInstance orbInstance_;

    // ------------------------------------------------------------------
    // IORURLScheme_impl constructor
    // ------------------------------------------------------------------

    public
    IORURLScheme_impl(ORBInstance orbInstance)
    {
        orbInstance_ = orbInstance;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    name()
    {
        return "ior";
    }

    public org.omg.CORBA.Object
    parse_url(String url)
    {
        int len = url.length() - 4; // skip "IOR:"

        if((len % 2) != 0)
            throw new org.omg.CORBA.BAD_PARAM(
                MinorCodes.describeBadParam(
                    MinorCodes.MinorBadSchemeSpecificPart) +
                    ": invalid length", 
                MinorCodes.MinorBadSchemeSpecificPart,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);

        byte[] data = HexConverter.asciiToOctets(url, 4);

        try
        {
	    //
	    // Error in conversion
	    //
	    if(data == null)
		throw new org.omg.CORBA.MARSHAL();

            com.ooc.OCI.Buffer buf =
                new com.ooc.OCI.Buffer(data, data.length);
            com.ooc.CORBA.InputStream in =
                new com.ooc.CORBA.InputStream(buf, 0, false);
            in._OB_readEndian();
            org.omg.IOP.IOR ior = org.omg.IOP.IORHelper.read(in);
            ObjectFactory objectFactory = orbInstance_.getObjectFactory();
            return objectFactory.createObject(ior);
        }
        catch(org.omg.CORBA.MARSHAL ex)
        {
            //
            // In this case, a marshal error is really a bad "IOR:..." string 
            // 
            throw new org.omg.CORBA.BAD_PARAM(
                MinorCodes.describeBadParam(
                    MinorCodes.MinorBadSchemeSpecificPart) + ": invalid IOR", 
                MinorCodes.MinorBadSchemeSpecificPart,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        }
    }

    public void
    destroy()
    {
        orbInstance_ = null;
    }
}
