// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

public class Logger_impl extends org.omg.CORBA.LocalObject implements WLogger
{
    // ------------------------------------------------------------------
    // Logger_impl private member implementations
    // ------------------------------------------------------------------

    private void
    message(String msg)
    {
        synchronized(System.err)
        {
            System.err.println(msg);
        }
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    info(String msg)
    {
        message(msg);
    }

    public void
    winfo(String msg)
    {
	info(msg);
    }

    public void
    error(String msg)
    {
        message("error: " + msg);
    }

    public void
    werror(String msg)
    {
	error(msg);
    }

    public void
    warning(String msg)
    {
        message("warning: " + msg);
    }

    public void
    wwarning(String msg)
    {
	warning(msg);
    }

    public void
    trace(String category, String msg)
    {
        String s = "[ " + category + ": ";
        int start = 0;
        int next;
        while((next = msg.indexOf('\n', start)) != -1)
        {
            s += msg.substring(start, next + 1);
            s += "  ";
            start = next + 1;
        }
        s += msg.substring(start);
        s += " ]";
        message(s);
    }

    public void
    wtrace(String category, String msg)
    {
	trace(category, msg);
    }
}
