// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

public class URLRegistry_impl extends org.omg.CORBA.LocalObject
                              implements URLRegistry
{
    private java.util.Hashtable schemes_ = new java.util.Hashtable();

    // ------------------------------------------------------------------
    // URLRegistry_impl constructor
    // ------------------------------------------------------------------

    public
    URLRegistry_impl()
    {
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    add_scheme(URLScheme scheme)
        throws com.ooc.OB.URLRegistryPackage.SchemeAlreadyExists
    {
        String name = scheme.name();
        if(schemes_.containsKey(name))
            throw new com.ooc.OB.URLRegistryPackage.SchemeAlreadyExists();
        schemes_.put(name, scheme);
    }

    public URLScheme
    find_scheme(String name)
    {
        return (URLScheme)schemes_.get(name);
    }

    public org.omg.CORBA.Object
    parse_url(String url)
    {
        if(url == null)
            throw new org.omg.CORBA.BAD_PARAM();

        int colon = url.indexOf(':');
        if(colon <= 0)
            throw new org.omg.CORBA.BAD_PARAM(
                MinorCodes.describeBadParam(MinorCodes.MinorBadSchemeName),
                MinorCodes.MinorBadSchemeName,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);

        String name = url.substring(0, colon).toLowerCase();
        URLScheme scheme = find_scheme(name);
        if(scheme == null)
            throw new org.omg.CORBA.BAD_PARAM(
                MinorCodes.describeBadParam(MinorCodes.MinorBadSchemeName),
                MinorCodes.MinorBadSchemeName,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);

        String urlCopy = name + url.substring(colon);
        return scheme.parse_url(urlCopy);
    }

    public void
    destroy()
    {
        java.util.Enumeration e = schemes_.elements();
        while(e.hasMoreElements())
        {
            URLScheme scheme = (URLScheme)e.nextElement();
            scheme.destroy();
        }
        schemes_.clear();
    }
}
