// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OB;

//
// An UnknownExceptionStrategy will be called by the ORB when a servant
// raises an unexpected exception
//
public class UnknownExceptionStrategy_impl extends org.omg.CORBA.LocalObject
    implements UnknownExceptionStrategy
{
    protected org.omg.CORBA.ORB orb_;

    public
    UnknownExceptionStrategy_impl(org.omg.CORBA.ORB orb)
    {
        orb_ = orb;
    }

    //
    // Handle an unknown exception. If this method doesn't throw
    // a SystemException, the ORB will return CORBA::UNKNOWN to
    // the client.
    //
    public void
    unknown_exception(UnknownExceptionInfo info)
    {
        String msg = "Servant method raised a non-CORBA exception";

        if(info.response_expected())
            msg += "\nClient receives this exception as CORBA::UNKNOWN";

        msg += "\noperation name: \"";
        msg += info.operation();
        msg += '"';

        com.ooc.OCI.TransportInfo transportInfo = info.transport_info();
        if(transportInfo != null)
        {
            String desc = transportInfo.describe();
            msg += '\n';
            msg += desc;
        }
        else
        {
            msg += "\nCollocated method call";
        }

        msg += "\n";
        msg += info.describe_exception();

        Logger logger = ((com.ooc.CORBA.ORB)orb_).logger();
        logger.warning(msg);
    }

    public void
    destroy()
    {
        orb_ = null;
    }
}
