// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

public final class ConFactoryRegistry_impl extends org.omg.CORBA.LocalObject
    implements com.ooc.OCI.ConFactoryRegistry
{
    //
    // All connector factories
    //
    java.util.Vector factories_ = new java.util.Vector();

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public synchronized void
    add_factory(ConFactory factory)
        throws FactoryAlreadyExists
    {
        String id = factory.id();

        for(int i = 0 ; i < factories_.size() ; i++)
            if(id.equals(((ConFactory)factories_.elementAt(i)).id()))
                throw new FactoryAlreadyExists(id);

        factories_.addElement(factory);
    }

    public synchronized ConFactory
    get_factory(String id)
        throws NoSuchFactory
    {
        for(int i = 0 ; i < factories_.size() ; i++)
        {
            ConFactory factory = (ConFactory)factories_.elementAt(i);
            if(id.equals(factory.id()))
                return factory;
        }

        throw new NoSuchFactory(id);
    }

    public synchronized ConFactory[]
    get_factories()
    {
        ConFactory[] result = new ConFactory[factories_.size()];
        factories_.copyInto(result);
        return result;
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    public
    ConFactoryRegistry_impl()
    {
    }
}
