// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI;

final class CurrentStateHolder
{
    java.util.Stack transportStack = new java.util.Stack();
}

final public class Current_impl extends org.omg.CORBA.LocalObject
    implements com.ooc.OCI.Current
{    
    private java.util.Hashtable stateKey_ = new java.util.Hashtable();

    // ------------------------------------------------------------------
    // Private and protected member implementations
    // ------------------------------------------------------------------

    private void
    destroyCurrentTSD()
    {
        Thread t = Thread.currentThread();
        stateKey_.remove(t);
    }

    private CurrentStateHolder
    getStateHolder()
    {
        Thread t = Thread.currentThread();
        CurrentStateHolder holder_ = (CurrentStateHolder)stateKey_.get(t);

        //
        // If the data isn't already allocated then allocate a new one
        //
        if(holder_ == null)
        {
            holder_ = new CurrentStateHolder();
            stateKey_.put(t, holder_);
        }

        return holder_;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public com.ooc.OCI.TransportInfo
    get_oci_transport_info()
    {
        CurrentStateHolder holder = getStateHolder();

        //
        // TODO: Exception?
        //
        if(holder.transportStack.isEmpty())
            return null;

        return (com.ooc.OCI.TransportInfo)holder.transportStack.firstElement();
    }

    public com.ooc.OCI.AcceptorInfo
    get_oci_acceptor_info()
    {
        com.ooc.OCI.TransportInfo info = get_oci_transport_info();
        if(info != null)
            return info.acceptor_info();
        else
            return null;
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    public void
    _OB_preinvoke(TransportInfo info)
    {
        CurrentStateHolder holder = getStateHolder();
        holder.transportStack.push(info);
    }

    public void
    _OB_postinvoke()
    {
        CurrentStateHolder holder = getStateHolder();
        holder.transportStack.pop();

        if(holder.transportStack.empty())
            destroyCurrentTSD();
    }
}
