// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.OCI.IIOP;

public final class Plugin_impl extends org.omg.CORBA.LocalObject
    implements com.ooc.OCI.Plugin
{
    private org.omg.CORBA.ORB orb_;     // The ORB
    private ListenerMap listenMap_;     // list of listenPoints

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return PLUGIN_ID.value;
    }

    public int
    tag()
    {
        return org.omg.IOP.TAG_INTERNET_IOP.value;
    }

    public void
    init_client(String[] params)
    {
        boolean keepAlive = true;
        int i = 0;
        while(i < params.length)
        {
            if(params[i].equals("--no-keepalive"))
            {
                keepAlive = false;
                i++;
            }
            else
            {
                throw new org.omg.CORBA.INITIALIZE("iiop: unknown client " +
                                                   "parameter `" + params[i] +
                                                   "'");
            }
        }

        //
        // Install the ConFactory
        //
        try
        {
            org.omg.CORBA.Object obj =
                orb_.resolve_initial_references("OCIConFactoryRegistry");
            com.ooc.OCI.ConFactoryRegistry registry =
                com.ooc.OCI.ConFactoryRegistryHelper.narrow(obj);
            registry.add_factory(
                    new ConFactory_impl(keepAlive, listenMap_));
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
        catch(com.ooc.OCI.FactoryAlreadyExists ex)
        {
            throw new org.omg.CORBA.INITIALIZE("OCI IIOP plug-in already " +
                                               "installed");
        }

        //
        // Install the "iiop" corbaloc URL protocol
        //
        try
        {
            org.omg.CORBA.Object obj =
                orb_.resolve_initial_references("URLRegistry");
            com.ooc.OB.URLRegistry registry =
                com.ooc.OB.URLRegistryHelper.narrow(obj);
            com.ooc.OB.URLScheme scheme = registry.find_scheme("corbaloc");
            com.ooc.OB.Assert._OB_assert(scheme != null);
            com.ooc.OB.CorbalocURLScheme corbaloc =
                com.ooc.OB.CorbalocURLSchemeHelper.narrow(scheme);
            corbaloc.add_protocol(new CorbalocProtocol_impl());
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
        catch(com.ooc.OB.CorbalocURLSchemePackage.ProtocolAlreadyExists ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
    }

    public void
    init_server(String[] params)
    {
        try
        {
            org.omg.CORBA.Object obj =
                orb_.resolve_initial_references("OCIAccFactoryRegistry");
            com.ooc.OCI.AccFactoryRegistry registry =
                com.ooc.OCI.AccFactoryRegistryHelper.narrow(obj);
            registry.add_factory(new AccFactory_impl(listenMap_));
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
        catch(com.ooc.OCI.FactoryAlreadyExists ex)
        {
            throw new org.omg.CORBA.INITIALIZE("OCI IIOP plug-in already " +
                                               "installed");
        }
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    public
    Plugin_impl(org.omg.CORBA.ORB orb)
    {
        orb_ = orb;
        listenMap_ = new ListenerMap();
    }
}
