// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package com.ooc.PortableInterceptor;

public final class POAPolicyFactory_impl extends org.omg.CORBA.LocalObject
    implements org.omg.PortableInterceptor.PolicyFactory
{
    public org.omg.CORBA.Policy
    create_policy(int type, org.omg.CORBA.Any val)
        throws org.omg.CORBA.PolicyError
    {
        try
        {
            if(type == org.omg.PortableServer.THREAD_POLICY_ID.value)
            {
                org.omg.PortableServer.ThreadPolicyValue v =
                    org.omg.PortableServer.ThreadPolicyValueHelper.
                    extract(val);
		return new com.ooc.PortableServer.ThreadPolicy_impl(v);
            }

            if(type == org.omg.PortableServer.LIFESPAN_POLICY_ID.value)
            {
                org.omg.PortableServer.LifespanPolicyValue v =
                    org.omg.PortableServer.LifespanPolicyValueHelper.
                    extract(val);
                return new com.ooc.PortableServer.LifespanPolicy_impl(v);
            }

            if(type == org.omg.PortableServer.ID_UNIQUENESS_POLICY_ID.value)
            {
                org.omg.PortableServer.IdUniquenessPolicyValue v =
                    org.omg.PortableServer.IdUniquenessPolicyValueHelper.
                    extract(val);
                return new com.ooc.PortableServer.IdUniquenessPolicy_impl(v);
            }

            if(type == org.omg.PortableServer.ID_ASSIGNMENT_POLICY_ID.value)
            {
                org.omg.PortableServer.IdAssignmentPolicyValue v =
                    org.omg.PortableServer.IdAssignmentPolicyValueHelper.
                    extract(val);
                return new com.ooc.PortableServer.IdAssignmentPolicy_impl(v);
            }

            if(type ==
               org.omg.PortableServer.IMPLICIT_ACTIVATION_POLICY_ID.value)
            {
                org.omg.PortableServer.ImplicitActivationPolicyValue v =
                    org.omg.PortableServer.ImplicitActivationPolicyValueHelper.
                    extract(val);
                return new com.ooc.PortableServer.
		    ImplicitActivationPolicy_impl(v);
            }

            if(type ==
               org.omg.PortableServer.SERVANT_RETENTION_POLICY_ID.value)
            {
                org.omg.PortableServer.ServantRetentionPolicyValue v =
                    org.omg.PortableServer.ServantRetentionPolicyValueHelper.
                    extract(val);
                return new com.ooc.PortableServer.
		    ServantRetentionPolicy_impl(v);
            }

            if(type ==
               org.omg.PortableServer.REQUEST_PROCESSING_POLICY_ID.value)
            {
                org.omg.PortableServer.RequestProcessingPolicyValue v =
                    org.omg.PortableServer.RequestProcessingPolicyValueHelper.
                    extract(val);
                return new com.ooc.PortableServer.
		    RequestProcessingPolicy_impl(v);
            }

            if(type == com.ooc.OBPortableServer.
	       SYNCHRONIZATION_POLICY_ID.value)
            {
                com.ooc.OBPortableServer.SynchronizationPolicyValue v =
                    com.ooc.OBPortableServer.
		    SynchronizationPolicyValueHelper.extract(val);
                return new com.ooc.OBPortableServer.
		    SynchronizationPolicy_impl(v);
            }

            if(type == com.ooc.OBPortableServer.
	       INTERCEPTOR_CALL_POLICY_ID.value)
            {
                boolean v = val.extract_boolean();
                return new com.ooc.OBPortableServer.
		    InterceptorCallPolicy_impl(v);
            }

        /*
         * We can't implement this yet since locality constrained objects
         * cannot be placed in CORBA::Any yet
         *
            if(type ==
               com.ooc.PortableServer.OB_DISPATCH_STRATEGY_POLICY_ID.value)
            {
                com.ooc.PortableServer.OBDispatchStrategy v =
                    com.ooc.PortableServer.OBDispatchStrategyHelper.
                    extract(val);
                return new OBDispatchStrategyPolicy_impl(v);
            }
        */

            throw new org.omg.CORBA.PolicyError(
                org.omg.CORBA.BAD_POLICY.value);
        }
        catch(org.omg.CORBA.BAD_OPERATION ex)
        {
            //
            // Any extraction failed
            //
            throw new org.omg.CORBA.PolicyError(
                org.omg.CORBA.BAD_POLICY_TYPE.value);
        }
    }
}
