// **********************************************************************
//
// Copyright (c) 2005-2006
// IONA Technologies PLC
// Dublin, Ireland and Waltham, MA, USA
//
// All Rights Reserved
//
// Licensed to apache under Apache 2.0 License - 2006
// **********************************************************************

package test.pi;

import org.omg.CORBA.*;
import org.omg.PortableInterceptor.*;

final public class ClientORBInitializer_impl extends org.omg.CORBA.LocalObject
    implements ORBInitializer
{
    //
    // From TestBase (no multiple inheritance)
    //
    public static void
    TEST(boolean expr)
    {
        if(!expr)
            throw new test.common.TestException();
    }

    static ClientProxyManager clientProxyManager;

    private static boolean local_;

    static void
    _OB_setLocal(boolean l)
    {
	local_ = l;
    }

    //
    // IDL to Java Mapping
    //

    public void
    pre_init(ORBInitInfo info)
    {
        //
        // Test: PICurrent::allocate_slot_id
        //
        if(!local_)
        {
	    int id = info.allocate_slot_id();
            TEST(id == 0);
        }

        //
        // Test: Register a policy factory
        //
        PolicyFactory pf = new MyClientPolicyFactory_impl();
        info.register_policy_factory(MY_CLIENT_POLICY_ID.value, pf);

        System.out.print("Registering client request interceptors... ");
	System.out.flush();
	clientProxyManager = new ClientProxyManager(info);
        System.out.println("Done!");
    }

    public void
    post_init(ORBInitInfo info)
    {
    }
}
